BeginPackage["Hilfsfunktionen`", "FixedNumberForm`", "Miscellaneous`PhysicalConstants`",
  "Utilities`FilterOptions`"];

connectDirs::usage = "connectDirs[dir1, dir2]
   verbindet dir1 mit dir2 und baut den Pfad unter bercksichtigung des \n
   Betriebssystems des Kernels zusammen. So kann man Kernel unter 
   NT und Unix starten.\n";

dateAndTime::usage = "dateAndTime gives a String containing the current 
  date and time including the name of the day and seconds."

dateTime::usage = "dateTime gives a String containing the current
  date and time."
  
dbgPrint::usage = "dbgPrint[id,msg] Prints the message msg if id is in Global`debugList.\n 
  id should be a string, which can be remembered easily i.e. the class name.\n 
  if id is not given the string will be \"misc\"\n 
  debugList is a list of strings. You can use the wildchar * to search for patterns.\n 
  i.e. debugList={\"*\"} prints all dbgPrint messages.\n 
  if debugList is not defined dbgPrint only takes 0.1 ms to evaluate.";

makeUsage::usage = "makeUsage[functionName_String, contextPath_String, usageText_String];
Defines the usage for the given function Name in two
contexts: \n 
a) In the current context, so that the function is public. \n
b) In the Context <Usages`contextPath`functionName>, so that the different
usages can be defined for the same methodName. The contextPath usually has the
form <className`>.";

outFkt::usage = "outFkt[value, mantissalength, exponentlength] formatierte Ausgabe mit FixedNumberForm,
defaults: mantissalength=8, exponentlength=2";

outStr::usage = "outStr[value, mantissalength, exponentlength] formatierte Ausgabe mit FixedNumberForm,
Rueckgabe als String, defaults: mantissalength=8, exponentlength=2\n
Wird als exponentLength 0 angegeben so wird die Angabe des Exponenten weggelassen z.b. outStr[11.23654, 4, 0]->+11.24\n
mantissalength steht dann fr die Gesamtlnge der Ziffern.";


num::usage = "Gibt den Zahlenwert einer physikalischen Konstante aus dem
Package Miscellaneous`PhysicalConstants`. Beispiel: num[ElectronCharge]."

interpolatingFunctionQ::usage = "interpolatingFunctionQ[interpolationsFkt]\n
gibt True zurck wenn die bergebene Funktion eine Interpolationsfunktion ist sonst False\n
z.B.: interpolatingFunctionQ[f]"

showStatus::usage = 
    "showStatus[string] writes String to the StatusArea of a Notebook.";

readListWithComment::usage =
"readListWithComment[file_String, opts] reads in a file similar to ReadList but ignoring any line beginning with #.\n
Options:\n
giveComment->False... if set to True only the Comment is returned. Default is False. 
Kleiner Tip: mit //TableForm sieht man den Kommentar schn formatiert.";

Options[readListWithComment]={giveComment->False};

getFilename::usage = "getFilename[str] returns the filename of string";

getFilenameWithoutExtension::usage = "getFilename[str] returns the filename of string without extension";

getPath::usage = "getPath[str] returns the path of string with slash ( or backslash) at the end";

export2Origin::usage = 
"export2Origin[opts] writes out a file in a origin compatible format which can be read into origin using 
the package \"ImportSpecial\". This means that the file begins with a comment section  in the form of 
\"# variable = value\" then the  data follows.\n
Options must be specified in the form export2Origin[{\"option1\"->value1,\"option2\"->value2,...}]:\n\n
  \"filename\"-> the filename where to wrote the parfile. This option must be specified.\n
  \"data\"-> contains the data in the form {{x1,y1,z1,...},{x2,y2,z2,...},...}\n
  \"dataType\"-> specifies how the data given by the option \"data\" should be wrote.\n
     The value will be added as comment # dataType = ...\n
     dataType can be one of the following:\n
     - \"string\" the data will be written without any modification as given by data\n
     - any other type the 2d-list of data will be writen in matrix form\n
       {{v1,v2},{v3,v4}}->v1   v2\\nv3  v4\n
  \"dataExpLength\"-> 2 if dataType is not \"string\"  this specifies the length of\n
     the exponent see outStr\n
  \"dataMantLength\"-> 8 if dataType is not \"string\"  this specifies the length of\n
     the manthis see outStr\n
  \"wrapColumn\"->Infinity if this option is specified the comment is wrapped at the specified column.
  \"comment\"-> if the value is a string, this string will be writen without any\n
     modifications if the value is a list, then it must be in the form \n
     {{\"var1\",val1},{\"var2\",val2},...}. Each entry will be formated\n
     in the following way: # var1 = val1. line wrapping is controlled by\n
     the option \"wrapColumn\"\n
     Following options can be set in origin:\n
        Worksheet options\n
          wksname = name of worksheet\n
          wkslabel = label of worksheet\n
          datatype = type of the daten _list_ / matrix\n
          col1name = name of worksheet column 1\n
          col1label = label of worksheet column 1\n\n
        Plot options:\n
          plotaxistype = type of the plot axis (xy) _linlin_ loglin linlog loglog\n
          plotlinetype = type of plotline _linesymb_ scatter line\n
          plotname = name of the  plotwindow\n
          plotlabel = label of the  plotwindow\n
          plotlegend = shall I generate a  legend? _yes_ no\n
          title = title inserted as label right over the plot bold and big size\n
          xtitle = title of the  x-axis\n
          xmin = Min. value of the x-axis \n
          xmax = Max. value of the x-axis \n
          ytitle = title of the  y-axis\n
          ymin = Min. value of the y-axis \n
          ymax = Max. value of the y-axis \n\n
        For contour-plots in addition to plot options:\n
          ztitle = title of the  z-axis\n
          zmin = Min. value of the z-axis \n
          zmax = Max. value of the z-axis \n
          zcount = number of colours to be used";

(******************************************************************************************************)
(***************************************** P R I V A T E **********************************************)
(******************************************************************************************************)

Begin["`Private`"]

num[physConst_] := physConst /. _[x_, ___] -> x;

connectDirs[a_, b_] := Module[{dir1 = a, dir2 = b, dirSum},
  (*entferne alle Slashs und Backslashs von hinten von dir1*)
  While[StringLength[dir1] > 0 && (StringTake[dir1, -1] == "/" || StringTake[dir1, -1] == "\\"),
    dir1 = StringTake[dir1, StringLength[dir1] - 1]
  ];
  (*entferne alle Slash und Backslash von vorn von dir2*)
  While[StringLength[dir2] > 0 && (StringTake[dir2, 1] == "/" || StringTake[dir2, 1] == "\\"),
    dir2 = StringTake[dir2, -(StringLength[dir2] - 1)]
  ];
  dirSum = dir1 <> "/" <> dir2;
  (*Unix*)
  Which[$OperatingSystem == "Unix",
      dirSum = StringReplace[dirSum, "\\" -> "/"];,
    $OperatingSystem == "WindowsNT",
      dirSum = StringReplace[dirSum, "/" -> "\\"]
  ];
  ToString[dirSum]
];

date2String[{year_,month_,day_,hour_,minute_,second_}] :=
  StringJoin[ToString /@ {DayOfWeek[{year, month, day}]," ",
  day,".",month,".",year," - ",hour,":",minute,":",second,"\n"}];

dateAndTime := date2String[Date[]];

date2StringAbbrev[{year_,month_,day_,hour_,minute_,second_}] :=
  StringJoin[ToString /@ {
  day,".",month,".",year," - ",hour,":",minute}];

dateTime := date2StringAbbrev[Date[]];

date2StringAbbrev[{year_,month_,day_,hour_,minute_,second_}] :=
  StringJoin[ToString /@ {
  day,".",month,".",year," - ",hour,":",minute}];

dateTime := date2StringAbbrev[Date[]];

makeUsage[pFunctionName_, pContextPath_, pUsageText_] := 
  Module[{contextPath=pContextPath, functionName = pFunctionName, usageText = pUsageText},
    If[StringTake[contextPath, 1] == "`", contextPath = StringDrop[contextPath, 1]];
    If[StringTake[contextPathString, -1] == "`", contextPath = StringDrop[contextPathString, -1]];
    If[StringTake[functionName, 1] == "`", functionName = StringDrop[functionName, 1]];
    If[StringTake[functionNameString, -1] == "`", functionName = StringDrop[functionNameString, -1]];
    (* \" und \n machten Probleme mit ToExpression deshalb StringReplace *)
    usageText=StringReplace[usageText, {"\"" -> "\\\"", "\n" -> "\\n", "\t" -> "\\t"}];
    ToExpression[functionName <> "::usage=\"" <> usageText <> "\""];
    ToExpression["Usages`" <> contextPath <> "`" <> functionName <> 
      "::usage=\"" <> usageText <> "\""];
  ];

outFkt[arg_, mantissalength_:8, exponentlength_:2, opts___]:= FixedNumberForm[arg, mantissalength, exponentlength, opts];

outStr[arg_, mantissalength_:8, exponentlength_:2, opts___]:=  outFkt[arg, mantissalength, exponentlength, opts]//ToString;

interpolatingFunctionQ[myFkt_] := (StringMatchQ[ToString[myFkt], "*InterpolatingFunction[{{*"])

export2Origin[opts___] := 
    Module[{comStr = "", dataStr = "", muell, comList, filename, stream, 
        wrapCol = Infinity, dataType = "list", dataExpLength = 2, 
        dataMantLength = 8},
      dbgPrint["export2Origin", ##];
      If[Length[{FilterOptions[{"filename"}, opts]}] == 0, 
        Message[exportParameterFile::error, 
            "Option \"filename\" missing!"];];
      If[Length[{FilterOptions[{"wrapColumn"}, opts]}] > 0, 
        wrapCol = "wrapColumn" /. opts;];
      If[Length[{FilterOptions[{"dataType"}, opts]}] > 0, 
        dataType = "dataType" /. opts];
      If[Length[{FilterOptions[{"dataExpLength"}, opts]}] > 0, 
        dataExpLength = "dataExpLength" /. opts];
      If[Length[{FilterOptions[{"dataMantLength"}, opts]}] > 0, 
        dataMantLength = "dataMantLength" /. opts];
      If[Length[{FilterOptions[{"comment"}, opts]}] > 0, 
        If[ListQ["comment" /. opts], comList = {};
          (muell = ToString[#[[2]]];
                While[StringLength[muell] > 0, 
		  dbgPrint["export2Origin","muell: ", muell];
                  AppendTo[
                    comList, {#[[1]], 
                      StringTake[muell, 
                        Min[StringLength[muell], wrapCol, 
                          StringPosition[muell, "\n"] - 1]]}];
                  muell = 
                    StringDrop[muell, 
                      Min[StringLength[muell], wrapCol, 
                        StringPosition[muell, "\n"]]];];) & /@ ("comment" /. 
                opts);
          If[Count[comList[[All, 1]], "dataType"] == 0, 
            AppendTo[comList, {"dataType", dataType}]];
          dbgPrint["comList", comList];
          comStr = "";
          muell = Max[StringLength /@ comList[[All, 1]]];
          (comStr = 
                  comStr <> "# " <> #[[1]] <> 
                    StringJoin@
                      PadRight[{}, muell - StringLength[#[[1]]], " "] <> 
                    " = " <> #[[2]] <> "\n") & /@ comList, 
          comStr = "comment" /. opts];
        dbgPrint["comStr", comStr];];
      If[Length[{FilterOptions[{"data"}, opts]}] > 0,
        Switch[dataType,
          "string",
          dataStr = "data" /. opts,
          _, 
          dataStr = 
              StringJoin @@ (outStr[#, dataMantLength, dataExpLength] <> 
                              " " & /@ # <> "\n" & /@ ("data" /. opts));
          ];
        stream = OpenWrite["filename" /. opts];
        WriteString[stream, comStr, dataStr];
        Close[stream];
        ];
      ];


showStatus[status_] := 
	LinkWrite[$ParentLink, SetNotebookStatusLine[FrontEnd`EvaluationNotebook[], ToString[status]]];

readListWithComment[file_String,opts___]:= Module[{opGiveComment},
  opGiveComment = giveComment /. {opts} /. Options[readListWithComment];
  If[opGiveComment,
    Flatten[
      Cases[ReadList[
          file, {String}], {x_?(Function[z, 
                  StringTake[z, 1] == "#"])} -> {x}]]
    ,
    Function[y, ReadList[StringToStream[y], Number]] /@ 
      Flatten[Cases[
          ReadList[
            file, {String}], {x_?(Function[z, 
                    StringTake[z, 1] =!= "#"])} -> {x}]
        ]
    ]
  ]

dbgPrint[msg_]:=dbgPrint["misc", msg];
dbgPrint[id_, msg__]:=If[Or @@ (Function[dbgx, StringMatchQ[ToString[id], dbgx]] /@ Global`debugList) === True, 
  Print[ToString[id],": ",msg]];

getFilename := (If[Length[StringPosition[#, {"/", "\\"}]] > 0, 
  StringTake[#, -(StringLength[#] - StringPosition[#, {"\\", "/"}] // Last // Last)], #]) &

getFilenameWithoutExtension := Module[{muell},
  (muell=getFilename[#];
  If[Length[StringPosition[muell, {"."}]] > 0, 
  StringTake[muell, (StringPosition[muell, {"."}] // Last // Last) - 1], muell]) &]

getPath := (If[Length[StringPosition[#, {"/", "\\"}]] > 0, 
        StringTake[#, (StringPosition[#, {"\\", "/"}] // Last // Last)], ""]) &

End[](*Private*)
EndPackage[]


