(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)













BeginPackage["etaOpt`","ClassesWithPoint`","Hilfsfunktionen`",
    "Miscellaneous`PhysicalConstants`","ExtendGraphics`LabelContour`",
    "Utilities`FilterOptions`","Global`"];



makeUsage["spectrum","spectrum",
    "sp = spectrum.new[] generates an new  spectrum Object. Special care has \
been taken for scaling the spectrum.  Following parameter are essential:\n
P_0,org = total power [0, \[Infinity]] of the origin spectrum as loaded from \
the file or generated for  blackbodies (given)\n
P_ur,org= integrated  spectrum [\[Lambda]_b,\[Lambda]_e] of the origin \
spectrum as  loaded from the file or generated for blackbodies (given)\n
C =  concentration of the spectrum in suns (to be set)\n
P_1= total power  [0,\[Infinity]] fo the spectrum for one-sun concentration \
(C=1) (to be  set)\n
P_0 = total power [0,\[Infinity]] of the scaled spectrum\n
 P_ur = integrated power [\[Lambda]_b,\[Lambda]_e] of the  scaled spectrum\n
Calculation is performed as followed:\n
 P_0= C P_1,  P_ur =  P_0/P_0,org P_ur,org\n
\n
All properties  of the spectrum can be modified during creation by Options. \
In the following  options with there default values are given:\n
 spectrumPath->whichFile[\"pvsim\",\"Math/QuellDaten/Spectra\"]. The  default \
path, from where the spectra files should be loaded\n
 concentration->1............. the concentration  factor.\n
 genFuncType->1............... sets the type for calculating
    the number of photons see setGenFuncType for more information.\n
 powerOfOneSun->1000...........power  of One Sun in W/m^2\n
 name->\"AM1_5d/am15d.dat\"....the name  for the spectral file including \
subdirs - this option can only be used if no  blackbody spectrum with \
\"blackbody->True\" is generated. If you want to  use your own spectra use \
\"spectrumPath\" to switch to your directory and  look at \
~pvsim/Math/QuellDaten/Spectra/AM1_5g/iec1000.dat for an example of  data \
file.\n
 blackBody->False..............if  set to True a blackbody spectrum is \
generated and the options for  \"generateBlackBody[]\" are available in \
addition. (see  generateBlackBody[])\n
\n
A spectrum.new[] with no options generates a blackbody with T=6000 K."];

Options[spectrum]={spectrumPath->Evaluate[connectDirs["..","spectra"]],
      concentration->1,powerOfOneSun->1000,name->"AM1_5g/iec1000.dat",
      blackBody->False,solidAngle\[Rule]4 Pi,genFuncType->1};

makeUsage["generateBlackBody","spectrum",
"generateBlackBody[] generates a 
blackbody spectrum with a certain emisivity in a rang from lambdaBegin to 
lambdaEnd with numberOfLambda values in the list. The total spectral power 
(P0org) is calculated via the T^4 Stefan Boltzmann law. The OneSunPower is 
set to this value automatically. The parameters are set with options. In the 
following options with there default values are given:\n
temperature->2000..... the temperature of the black body in K\n
epsilon->1............ the emissivity of the body (1 for blackbody is 
default)\n
lambdaBegin->1........ begining of the spectral range in nm. 0 < lambdaBegin 
< lambdaEnd!\n
lambdaEnd->10^9....... end of the spectral range in nm \n
numberOfLambdas->2.... number of datapoints for the list. All calculations 
are performed with the analytic expression. Thus this option does not 
influence any integrated results like power generatedPhotons....\n
solidAngle->4 Pi...... sets the solidangle in which the spectrum is emitted. 
This scales the intensity of the spectrum, and has only effect on the 
PowerOfOriginSpectrum as the spectrum is once more scaled to fit the 
OneSunPower\n
dLambda->............. optional to \"numberOfLambdas\" dLambda can be used, 
which give the distance between two spectral datapoints in nm. All 
calculations are performed with the analytic expression. Thus this option 
does not influence any integrated results like power generatedPhotons....\n
"];

Options[generateBlackBody]={temperature\[Rule]6000,epsilon\[Rule]1,
      lambdaBegin\[Rule]1,lambdaEnd\[Rule]1*^9,numberOfLambdas\[Rule]2,
      dLambda\[Rule]10,solidAngle\[Rule]4 Pi};

makeUsage["giveConcentration","spectrum","giveConcentration[] returns the 
concentration factor."];

makeUsage["giveFileName","spectrum","giveFileName[] returns the name of the 
loaded file. if a blackbody was generated \"\" is returned"];

makeUsage["giveGenFunc","spectrum",
    "giveGenFunc[] returns the function used in giveNumberOfPhotons to \
calculated the number of photons Integrate[GenFunc]. To use the function do \
something like f= sp.giveGenFunc[]; f[400]"];

\!\(\(makeUsage["\<giveGenFuncType\>", "\<spectrum\>", \
"\<giveGenFuncType[type]returns the integration method in giveNumberOfPhotons \
to calculate the number of photons. type can be one of the following:
1: Integrate[\[Lambda] Interpolation[{\[Lambda],E},Order->0]]=\[Sum]E_m \
\[Lambda]_m, E_m and \[Lambda]_m are meanvalues of the interval
   recommended by ASTM
2: Integrate[\[Lambda] Interpolation[{\[Lambda],E},Order->1]]
   possible method
3: Integrate[Interpolation[{\[Lambda],E \[Lambda]},Order->1]]
   quick and dirty but false\>"];\)\)

makeUsage["giveList","spectrum",
    "giveList[] returns a list 
    containing wavelength in nm and the spectraldensity in {nm,W/(m^2 
    \[Micro]m)}, e.g. {{400,1.2223},{450,1.432},...}"];

makeUsage["giveName","spectrum","giveName[] returns the name of the selected 
spectrum with information on concentration and P0 as string, e.g. 
\"am15d_100x1000W\""];

makeUsage["giveNameList","spectrum",  
    "giveNameList[] gives 
    a list of names of all available spectra, e.g. 
    {\"AM1_5g/standard.dat\",\"AM0/standard.dat\"}"];

makeUsage["giveNumberOfPhotons","spectrum",  
    "giveNumberOfPhotons[] gives the number of photons of 
    the spectrum. If no options are used, the whole spectrum is used. With \
the 
    following options one can limit the range for which the number of photons \

    should be calculated:\n
    lambdaBegin->\"Begin of spectra\".. gives the wavelength in nm where to \
start 
    calculations - default is spectrum begin.\n
    lambdaEnd->\"End of spectra\"...... gives the wavelength in nm where to \
end 
    calculations - default is spectrum end.\n"];

makeUsage["givePower","spectrum",
    "givePower[] returns the integrated power of the 
spectrum for the used range determined by lambdaBegin and lambdaEnd in W/m^2 
taking into account the PowerOfOneSun and the concentration factor. Options:\n\

lambdaBegin->\"Begin of spectra\".. gives the wavelength in nm where to start \

calculations - default is spectrum begin.\n
lambdaEnd->\"End of spectra\"...... gives the wavelength in nm where to end 
calculations - default is spectrum end.\n"];

makeUsage["givePowerOfOneSun","spectrum",
    "givePowerOfOneSun[] returns the total 
power [0,\[Infinity]] for 1 sun concentration of the spectrum in 
W/m^2"];

makeUsage["givePowerOfOrigin","spectrum","givePowerOfOrigin[] returns the 
integrated power for spectrum as loaded from the file or generated for 
blackbody W/m^2."];

makeUsage["giveSpectrumPath","spectrum",
    "giveSpectrumPath[] give the absolute 
path to the spectra data files, which can be loaded via setSpectrum. See also \

setSpectrumPath, giveNameList, giveName."];

makeUsage["giveTemperature","spectrum",
    "giveTemperature[] returns the temperature of the blackbody spectrumin \
K."];

makeUsage["giveTotalPower","spectrum",
    "giveTotalPower[] returns the total power 
[0,\[Infinity]] of the spectrum in W/m^2 taking into account the 
PowerOfOneSun and the concentration factor."];

makeUsage["giveTotalPowerOfOrigin","spectrum",
    "giveTotalPowerOfOrigin[] returns 
the total power [0,\[Infinity]] of the origin spectrum as loaded from the 
file or generated for blackbody in W/m^2."];

makeUsage["giveValue","spectrum",
    "giveValue[\[Lambda]] returns for a given \[Lambda] [in nm] the \
spectraldensity  in W/(m^2 \[Micro]m)."];

makeUsage["giveValueList","spectrum",
    "giveValueList[] returns a list containing the spectraldensity in W/(m^2 \
\[Micro]m), e.g. {1.2223,1.432,...}"];

makeUsage["giveValueMin","spectrum",
    "giveValueMin[] returns the minmum of the  spectraldensity in W/(m^2 \
\[Micro]m), e.g. 1.2223. For a 
    loaded spectrum the list is used for blackbody returns 0."];

makeUsage["giveValueMax","spectrum",
    "giveValueMax[]  returns the maximum of the  spectraldensity in W/(m^2 \
\[Micro]m), e.g. 1.432.  For a loaded spectrum the list is used. for \
blackbody WiensKonstant is used  I(\[Lambda]_max), \[Lambda]_max=2.897756 \
10^6/T  [nm]"];

makeUsage["giveWavelengthList","spectrum",
    "giveWavelengthList[] returns a list containing the 
    wavelengths in nm, e.g. {450,470...}"];

makeUsage["giveWavelengthMin","spectrum",
    "giveWavelengthMin[] returns the minmum of the wavelength range in nm, \
e.g. 450"];

makeUsage["giveWavelengthMax","spectrum",
    "giveWavelengthMax[] returns the maxmum of the wavelength range in nm, \
e.g. 1200"];

makeUsage["setConcentration","spectrum",
    "setConcentration[Concentration] Scales 
the power density of the spectrum according to the OneSunPower. Default = \
1."];

makeUsage["setGenFunc","spectrum",
    "setGenFunc[pureFunction] sets the function used in giveNumberOfPhotons \
to calculated the number of photons Integrate[GenFunc]. purFunction must be a \
pure function with one slot. E.g. setGenFunc[(100 + #)&]"];

\!\(\(makeUsage["\<setGenFuncType\>", "\<spectrum\>", \
\*"\"\<setGenFuncType[type] sets the Integration Method in \
giveNumberOfPhotons to calculate the number of photons. type must be one of \
the following:\n1: Integrate[\[Lambda] \
Interpolation[{\[Lambda],\!\(E\_m\)},Order->0]]=\[Sum]E_m\[Lambda]_m, E_m and \
\[Lambda]_m are meanvalues of the interval\n   recommended by ASTM\n2: \
Integrate[\[Lambda] Interpolation[{\[Lambda],E},Order->1]]\n   possible \
method\n3: Integrate[Interpolation[{\[Lambda],E \[Lambda]},Order->1]]\n   \
quick and dirty but false\>\""];\)\)

makeUsage["setPowerOfOneSun","spectrum",
    "setPowerOfOneSun[PowerInWatt] scales the 
spectrum, so that the integrated powerdensity = PowerInWatt. Default is 1000 
W/m^2."];

makeUsage["setSpectrum","spectrum",
    "setSpectrum[spectrumName] sets the spectrum. 
Default is \"AM1_5g/iec1000.dat\". Use \"giveNameList\" to see a list of all 
available spectra, or use \"setSpectrumPath[]\" to change to the appropriate 
directory of spectra."];

makeUsage["setSpectrumPath","spectrum",
    "setSpectrum[absDir] sets the directory to 
which the spectrumName will be appended. absDir must be absolute and can be 
in DOS or Unix convention but must be avalaible for the MathKernel."];



makeUsage["singleJunction","singleJunction",
    "new[] Creates an abstract class of a 
singleJunction. Following options can be used:\n
bandgap->0....... sets the bandgap of the junction in eV\n
name->\"\"......... sets the name of the junction.\n
temperature->300. sets the temperature of the junction in K\n
eqeMax->1........ sets the external quantum efficiency of a junction is a 
squarefunction with EQE = EqeMax for E>=Eg and EQE = 0 for E<Eg.\n
no->1........... sets the value of refractive index of the material over the 
junction. For more information see setno[].\n
nu->0........... sets the value of refractive index of the material under the \

junction. For more information see setnu[]."];

Options[singleJunction]={bandgap->0,name->"",temperature->300,eqeMax->1,no->1,
      nu->0};



makeUsage["setEqeMax","singleJunction",
    "setEqeMax[EqeMax] assumes the EQE of a junction 
to be a squarefunction with EQE = EqeMax for E>=Eg and EQE = 0 for 
E<Eg."];



makeUsage["calcAll","singleJunction",
    "calcAll[] calculates Isc, I0, Voc of the cell in 
this order."];

makeUsage["calcIsc","singleJunction",
    "calcIsc[] calculates Isc for a given spectrum. 
This method must be defined in child classes."];

makeUsage["calcI0","singleJunction",
    "calcIsc[] calculates I0. This method must be 
defined in child classes."];

makeUsage["calcVoc","singleJunction",
    "calcVoc[] calculates Voc. This method must be 
defined in child classes."];

makeUsage["giveModelAcronym","singleJunction",
    "giveModelAcronym[] returns a acronym for 
the JunctionModel e.g. SJ for SIngleJunction, 1D for oneDiodeModel 1D1T for 
oneDiodeJunctionI0FirstTerm."];

makeUsage["giveBandgap","singleJunction",
    "giveBandgap[] returns the Bandgap of the 
Junction in eV (same as giveEg[])."];

makeUsage["giveEg","singleJunction",
    "giveEg[] returns the Bandgap of the Junction in eV 
(same as giveBandgap[])."];

makeUsage["giveEqeMax","singleJunction",
    "giveEqeMax[] returns the maximum of the eqe. 
The external quantum efficiency of a junction is a squarefunction with EQE = 
EqeMax for E>=Eg and EQE = 0 for E<Eg."];

makeUsage["giveIsc","singleJunction",
    "giveIsc[] returns Isc in mA/cm^2. Must be 
calculated with calcIsc[] or set with setIsc[]."];

makeUsage["giveI0","singleJunction",
    "giveI0[] returns I0 in mA/cm^2. Must be calculated 
with calcI0[]"];

makeUsage["giveLambdaBegin","singleJunction",
    "giveLambdaBegin[] returns the beginning 
of the spectra in nm. LambdaBegin is used to calculate Isc"];

makeUsage["giveLambdaG","singleJunction",
    "giveLambdaG[] returns the Bandgap of the 
junction in nm (see giveBandgap[])."];

makeUsage["giveName","singleJunction",
    "giveName[] returns the name of the junction as 
String."];

makeUsage["giveno","singleJunction","giveno[] returns the refractive index of the material 
situate over the junction. This factor is used for calculating I0 see 
setno[]."];

makeUsage["givenu","singleJunction","givenu[] returns the refractive index of the material 
situate under the junction. This factor is used for calculating I0 see 
setnu[]."];

makeUsage["giveTemperature","singleJunction",
    "giveTemperature[] returns the temperature 
of the junction in K."];

makeUsage["giveSpectrum","singleJunction",
    "giveSpectrum[] returns the spectrum from 
which Isc can be calculated as object of type spectrum."];

makeUsage["giveV","singleJunction",
    "giveV[I] returns the voltage mV for a given current 
in mA/cm^2."];

makeUsage["setBandgap","singleJunction",
    "setBandgap[bandgap] sets the bandgap of 
junction in eV."];

makeUsage["setI0","singleJunction",
    "setI0[I0] sets I0 of the junction in mA/cm^2."];

makeUsage["setIsc","singleJunction",
    "setIsc[Isc] sets Isc of the junction in mA/cm^2. 
This is needed to achieve currentmatching for semi-transparent 
cells"];

makeUsage["setLambdaG","singleJunction",
    "setLambdaG[bandgap] sets the bandgap of 
junction in nm."];

makeUsage["setName","singleJunction",
    "setName[name] sets the name of junction. Name is 
a string."];

makeUsage["setno","singleJunction",
    "setno[value] sets the refractive index of the 
material situate over the junction.\n
A value of 0 means that no radiation take place on this side.\n
A value of 1 means that all photons with in a cone of sin(theta)<1/n will 
emerge of the cell - where theta is the angle between the ray and the surface \

normal.\n
A value of n (where n is the refractive index of the junction itself and 
typically around 3.6) means that all photons will emerge of the cell\n
Default is 1.\n
In the calculation of I0 no and nu are used as a factor 
(no^2+nu^2)."];

makeUsage["setnu","singleJunction",
    "setnu[value] sets the refractive index of the 
material situate under the junction.\n
A value of 0 means that no radiation take place on this side.\n
A value of 1 means that all photons with in a cone of sin(theta)<1/n will 
emerge of the cell - where theta is the angle between the ray and the surface \

normal.\n
A value of n (where n is the refractive index of the junction itself and 
typically around 3.6) means that all photons will emerge of the cell\n
Default is 0.\n
In the calculation of I0 no and nu are used as a factor (no^2+nu^2)"];

makeUsage["setSpectrumBegin","singleJunction",
    "setSpectrumBegin[spectrum,lambdaBegin] 
sets the spectrum, and the begining of the spectrum. This must be done before \

calculating Isc. lambdaBegin is needed because not the whole spectrum is 
transfered to Isc. spectrum is an object of type spectrum. lambdaBegin is in 
nm."];

makeUsage["setTemperature","singleJunction",
    "setTemperature[temp] sets the temperature 
of junction in K."];



makeUsage["oneDiodeJunction","oneDiodeJunction",
    "new[] creates an single Junction object 
based on the one diode model. The dark current Io is calculated with the 
following formula:\n
(2 q Pi)/(h^3c^2) [k T(q Eg)^2 - 2(k T)^2 (q Eg) + 2(k T)^3] Exp[-(q Eg)/(k 
T)] 0.1\n
All options of the abstract parentclass \"singleJunction\" can be used for 
setup. only the methods calcI0, calcIsc, calcVoc and giveV are 
overwriten."];

makeUsage["calcIsc","oneDiodeJunction",
    "calcIsc[] calculates the short circuit current in 
mA/cm^2 from a given spectrum begining from a certain wavelength upto to the 
bandgap of the junction - spectrum and wavelength begin can be set via 
setSpectrumBegin[]). calcIsc[] do not return any value. To get the value use 
giveIsc[]."];

makeUsage["calcI0","oneDiodeJunction",
    "calcI0[] calculates I0. This method must be 
defined in child classes."];

makeUsage["calcVoc","oneDiodeJunction",
    "calcVoc[] calculates the open circuit voltage Voc 
in mV using following formular:\n
  (kT)/q Log[Isc/I0]*10^3\n
 10^3 converts the value into mV calcVoc[] do not return any value. To get \
the value use giveVoc[]."];

makeUsage["giveModelAcronym","oneDiodeJunction",
    "giveModelAcronym[] returns a acronym for 
the JunctionModel e.g. SJ for SIngleJunction, 1D for oneDiodeModel 1D1T for 
oneDiodeJunctionI0FirstTerm."];

makeUsage["giveV","oneDiodeJunction",
    "giveV[I] returns the voltage mV for a given current 
in mA/cm^2."];



makeUsage["oneDiodeJunctionI0FirstTerm","oneDiodeJunctionI0FirstTerm",
    "new[] creates an single 
Junction object based on the one diode model. The dark current Io is 
calculated with the following formula:\n
(2 q Pi (myno^2+mynu^2))/(h^3 c^2)(k T(q Eg)^2)Exp[(-q Eg)/(k T)] 0.1;\n
All options of the abstract parentclass \"oneDiodeJunction\" can be used for 
setup. only the methods calcI0, calcIsc, calcVoc and giveV are 
overwriten."];

makeUsage["calcI0","oneDiodeJunctionI0FirstTerm",
    "calcIsc[] calculates I0. This method must be 
defined in child classes."];

makeUsage["giveModelAcronym","oneDiodeJunctionI0FirstTerm",
    "giveModelAcronym[] returns a acronym for 
the JunctionModel e.g. SJ for SIngleJunction, 1D for oneDiodeModel 1D1T for 
oneDiodeJunctionI0FirstTerm."];

makeUsage["giveV","oneDiodeJunctionI0FirstTerm",
    "giveV[I] returns the voltage mV for a given current 
in mA/cm^2."];

makeUsage["setI0","oneDiodeJunctionSemiEmpirical",
    "setI0[I0] sets I0 of the junction in mA/cm^2."];



makeUsage["oneDiodeJunctionSemiEmpirical","oneDiodeJunctionSemiEmpirical",
    "new[] creates an single 
Junction object based on the one diode model. The dark current Io is 
calculated with an empirical formula which can be set with setI0Func."];

Options[oneDiodeJunctionSemiEmpirical]={i0Func->Function[x,0]};

makeUsage["calcI0","oneDiodeJunctionSemiEmpirical",
    "calcI0[] calculates the darkcurrent I0 in mA/cm^2 
using following formular:\n
  (2 q Pi)/(h^3c^2) [k T(q Eg)^2 - 2(k T)^2 (q Eg) + 2(k T)^3] Exp[-(q Eg)/(k \

T)] 0.1\n
 0.1 converts the value into mA/cm^2. calcI0[] do not return any value. To 
get the value use giveI0[]."];

makeUsage["giveI0Func","oneDiodeJunctionSemiEmpirical",
    "giveI0Func[] returns  the pure function to calculated I0 with. The pure \
function is called with 3 slots.
1. slot: bandgap [eV]
2. slot: temperature [K]
3. slot: concentration [suns]. 
The function returns the current in mA/cm^2.
E.g.: func=giveI0Func[];func[1.3,300,100]=>..."];

makeUsage["giveI0","oneDiodeJunctionSemiEmpirical",
    "giveI0[] returns I0 in mA/cm^2. Must be calculated with calcI0[]"];

makeUsage["giveModelAcronym","oneDiodeJunctionSemiEmpirical",
    "giveModelAcronym[] returns a acronym for 
the JunctionModel e.g. 1Dse for oneDiodeJunctionSemiEmpirical, 1D for \
oneDiodeModel 1D1T for 
oneDiodeJunctionI0FirstTerm."];

makeUsage["setI0Func","oneDiodeJunctionSemiEmpirical",
    "setI0Func[purefunction] sets the function to calculated I0 with.
to purefunction. pureFunction must be a pure function with up to 3 slots.
1. slot: bandgap [eV]
2. slot: temperature [K]
3. slot: concentration [suns]. 
the function must return the current in mA/cm^2
E.g.: setI0Func[(#3 Exp[-#1/(k #3)])&]"];



makeUsage["container","container",
    "new[] creates an Object container, which is 
used to navigate through a list of items. Following options are avalaible:\n
name->\"\".... each container can have a name, which can be retrieved with 
giveName[].\n
item->{}...... a list of items, which can be anything, i.e. an object, a 
number, another container..."];

Options[container]={item\[Rule]{},name\[Rule]""};

makeUsage["appendTo","container",
    "appendTo[item] appends \"item\" to the itemlist."];

makeUsage["evaluateForEachItem","container",
    "evaluateForEachItem[method] this 
method makes only sense, if container only contains container and Objects. In \

this case evaluateForEachItem goes down in the hierachy of container, and if 
it finds an object which is not a container, evaluates the method, and 
returns the returnvalue if any. I.e. evaluateForEachItem[giveName[]] returns 
{{cell1,cell2},{cell3}}"];

makeUsage["giveCurrent","container",
    "giveCurrent[] returns the current item in the 
list. If there is no list or no item to return, it returns Null."];

makeUsage["giveFirst","container",
    "giveFirst[] returns the first item in the list. 
If there is no list or no item to return, it returns Null."];

Options[giveFirst]={move\[Rule]True};

makeUsage["giveItem","container",
    "giveItem[position] returns the item at given 
position in the list. I.e. giveItem[3] returns the 3th item in the list. If 
there is no list or no item to return, it returns Null."];

Options[giveItem]={move\[Rule]True};

makeUsage["giveLast","container",
    "giveLast[] returns the last item in the list. If 
there is no list or no item to return, it returns Null."];

Options[giveLast]={move\[Rule]True};

makeUsage["giveList","container","giveList[] returns the whole list of 
items."];

makeUsage["giveName","container",
    "giveName[] returns the name of the container as 
string."];

makeUsage["giveNext","container",
    "giveNext[] returns the next item in list. If 
there is no list or no item to return, it returns Null."];

Options[giveNext]={move\[Rule]True};

makeUsage["giveNumberOf","container",
    "giveNumberOf[] returns the number of items 
in the list."];

makeUsage["givePosition","container",
    "givePosition[] returns the current position 
in the item list. I.e. giveItem[givePosition] is the same as 
giveCurrent[]."];

makeUsage["givePrevious","container",
    "givePrevious[] returns the previous item in 
list. If there is no list or no item to return, it returns Null."];

Options[givePrevious]={move\[Rule]True};

makeUsage["isFirst","container",
    "isFirst[] returns the True if the current item is 
the first item. If there is no list or no item to return, it returns 
False."];

makeUsage["isLast","container",
    "isLast[] returns the True if the current item is 
the last item. If there is no list or no item to return, it returns 
False."];

makeUsage["setName","container",
    "setName[name] sets the name of the container. 
I.e. setName[\"my list\"]."];

makeUsage["setList","container","setList[list] sets the whole list. I.e. 
setList[{item1,item2}]."];

makeUsage["moveToFirst","container",
    "moveToFirst[] moves to the first item of the 
list but returns nothing. I.e. moveToFirst[];isFirst[] returns 
True."];

makeUsage["moveToLast","container",
    "moveToLast[] moves to the last item of the 
list but returns nothing. I.e. moveToLast[];isLast[] returns True."];

makeUsage["moveTo","container",
    "moveToLast[position] moves to a given position in 
the list but returns nothing. I.e. moveTo[3];givePosition[] returns 
3."];



makeUsage["monoStack","monoStack",
    "new[] creates an object of type monoStack. 
Following options are available (default values are shown):\n
currentMatching->True... if set to true an algorithm which implements 
semi-transparent top cells is used to achieve current matching\n
As this class is derived from the class container every option of container 
can be used in addition.\n
Example: to create a monolithic tandem of two onediode junctions: \n
  monoStack.new[name->\"monolithic tandem\",item->{\n
    oneDiodeJunction[name->\"top cell\",bandgap->2],\n
    oneDiodeJunction[name->\"bottom cell\",bandgap->1]\n
  }]"];

makeUsage["calcIsc","monoStack",
    "calcIsc[] calculates the shortcircuit current of 
the stack. If currentMatching is True an algorithm which implements 
semi-transparent top cells is used to achieve current matching. Otherwise the \

shortcircuit current of all junction is set to their minimum."];

makeUsage["calcMpp","monoStack",
    "calcMpp[] calculates the current at maximum power 
point. Before this method can be used Isc of the junctions must be 
calculated. To do this use calcIsc[].\n I0 is calculated in this method 
calling calcI0 of the single junctions. Mpp is found by building a function 
P=I* giveV(I) where giveV is a method of the single junction. and then 
setting the first derivative=0\n 
The values for Impp, Pmpp and Vmpp are set and can be retrieved by the 
apropriate give method - i.e. giveImpp[]..."];

makeUsage["giveCurrentMatching","monoStack",
    "giveCurrentMatching[] returns True if 
currentmatching is turned on for this stack otherwise False."];

makeUsage["giveIsc","monoStack",
    "giveIsc[] returns the shortcircuit current in 
mA/cm^2 calculated with calcIsc[]. giveIsc[] returns 0 if calcIsc[] was not 
called in advance."];

makeUsage["giveImpp","monoStack",
    "giveImpp[] returns the current at maximum power 
point in mA/cm^2 calculated with calcMpp[]. giveImpp[] returns 0 if calcMpp[] \

was not called in advance."];

makeUsage["givePmpp","monoStack",
    "givePmpp[] returns the power at maximum power 
point in mW/cm^2 calculated with calcMpp[]. givePmpp[] returns 0 if calcMpp[] \

was not called in advance."];

makeUsage["giveV","monoStack",
    "giveV[I] returns the voltage mV for a given current 
in mA/cm^2."];

makeUsage["giveVmpp","monoStack",
    "giveVmpp[] returns the voltage at maximum power 
point in mV calculated with calcMpp[]. giveVmpp[] returns 0 if calcMpp[] was 
not called in advance."];

makeUsage["setCurrentMatching","monoStack",
    "setCurrentMatching[True/False] if 
parameter is True (False) turns currentmatching on (off)."];

makeUsage["setBandgap","monoStack","setBandgap[bandgap] sets the bandgap of 
junction in eV. I.e. setBandgap[{3,2,1}] sets the bandgap of 
the first cell to 3 eV the second 2 eV..."];

makeUsage["setSpectrum","monoStack",
    "setSpectrum[spectrumName] sets the spectrum. 
Default is \"AM1_5g/iec1000.dat\". Use \"giveNameList\" to see a list of all 
available spectra, or use \"setSpectrumPath[]\" to change to the appropriate 
directory of spectra."];

makeUsage["setSpectrumBegin","monoStack",
    "setSpectrumBegin[spectrum,lambdaBegin] 
Perform two things:\n
1. let all junctions know, which spectrum to use for calulating Isc.\n
2. let all junctions know, where to start integration of the spectrum. 
Thereby the start point of the topmost junction is set to lambdaBegin. The 
starting point of each following junction is set to the bandgap of his 
previous neighbour."];

makeUsage["setTemperature","monoStack",
    "setTemperature[temp] sets the temperature 
of each junction in the stack to temp in K."];



makeUsage["mechStack","mechStack",
    "new[] creates an object of type mechStack which 
contains monolithic stacks. 
As this class is derived from the class container every option of container 
can be used in addition.\n
Example: to create a mechanically stacked tandem of two onediode junctions: \n\

  mechStack.new[name->\"mechanically stacked tandem\",item->{\n
    monoStack.new[name->\"top monoStack\",item->{ 
      oneDiodeJunction[name->\"top cell\",bandgap->2]
    }],\n
    monoStack.new[name->\"bottom monoStack\",item->{ 
      oneDiodeJunction[name->\"bottom cell\",bandgap->1]
    }]\n
  }]"];

makeUsage["giveBandgapPatternString","mechStack","giveBandgapPatternString[] 
returns a string containing the structure of the cell. I.e. a monolithical 
tandem with a single junction under it has a structure of {{E1,E2},{E3}}."];

makeUsage["calcMpp","mechStack",
    "calcMpp[] calculates the maximum power point of 
all monoStacks at sets Pmpp which can be retrieved with givePmpp[]."];

makeUsage["givePmpp","mechStack",
    "givePmpp[] returns the power at maximum power 
point previously calculated with calcMpp[] in mW/cm^2."];

makeUsage["setBandgap","mechStack",
    "setBandgap[list] sets the bandgaps of all 
junctions to the values in list. I.e. setBandgap[{3,2,1}] sets the bandgap of \

the first cell to 3 eV the second 2 eV..."];

makeUsage["setSpectrumBegin","mechStack",
    "setSpectrumBegin[] sets the spectrum and 
the starting point for calculating Isc of the junctions. Following options 
can be used (showing default values):\n
spectrum->..... no default value, an object of type spectrum\n
lambdaBegin->.. starting point of the spectrum in nm begining at this 
wavelength the current integration should be done."];

Options[setSpectrumBegin]={spectrum\[Rule]spectrum.new[],lambdaBegin\[Rule]0};

makeUsage["setTemperature","mechStack",
    "setTemperature[T] sets the Temperature of 
each junction in monoStack to T in K."];



makeUsage["etaOpt","etaOpt",
    "new[] creates an object of type etaOpt. Following 
options are available (showing default values):\n
  name->\"\"................ sets the name of the simmulation. this is used 
by save an export messages for comments.\n
  item->mechStack.new[].... tells etaOpt which mechStack to use for 
calculations.\n
  spectrum->spectrum.new[]. tells etaOpt which spectrum to use.\n
  lambdaBegin->0........... tells etaOpt where to begin the spectrum of the 
top cell\n
  bandgapRange->{}......... tells etaOpt for which bandgaps the calculations 
should be performed. for each junction the list must contain a list with 
minimum value, maximum value, and step size in eV. I.e. To calculate for 
tandem the top cell 1.1 - 2 eV every 0.05 eV and bottom cell the range 0.5-1 
eV every 0.1 eV following must be typed: {{1.1,2,0.05},{0.5,1,0.1}}"];

Options[etaOpt]={name\[Rule]"",item\[Rule]mechStack.new[],
      spectrum->spectrum.new[],bandgapRange\[Rule]{},lambdaBegin\[Rule]0};

makeUsage["calcAll","etaOpt",
    "calcAll[] starts the calculation through the whole range.
For calculating the efficiency spectrum.giveTotalPower[] is used.\n
 The result can be read with giveData[], graphically displayed with plot[], 
saved with saveAll[] or exported ap plain text for use in other programs like \

Origin with export[]"];

makeUsage["calcMpp","etaOpt","calcMpp[bandgapList] starts the calculation of 
the power at maximum powerpoint for a given bandgapList. I.e. for a tandem 
calcMpp[{{2,1}}] calculates the power for top cell set to 2 eV bottom cell 
set to 1 eV.\n
For calculating the efficiency spectrum.giveTotalPower[] is used.\n
The results can be retrieved as a List {eta,...} with giveMpp[]."];

makeUsage["calcEtaMax","etaOpt","calcEtaMax[] tries to find the maximum 
efficiency for a specified range. \n\n
Options (given values are defaults):\n
  bandgapRangeList->{}... This option must be specified, and gives the inital \

set of bandgaps.\n
  finestStep->0.01....... if all bandgapsteps are less or equal to this the 
calculation stops.\n
  stepsPerInterval->3... how many points should be calculated in each 
interval. Must be bigger than 3.\n
  debug->False........... If set to true some debug information will be 
printed on the screen during calc.\n\n
I.e. for a tandem cell: 
calcEtaMax[bandgapRangeList->{{1,2},{0.4,1.4}},finestStep->0.01,
stepsPerInterval->4].\n
In a first step eta is calculated for all bandgaps defined by step 
({1,1.25,1.5,1.75,2} for the top cell {0.4,0.65,0.9,1.15,1.4} for the bottom 
cell. Than the maximum is calculated. The new range is set to maxvalue +/- 
interval size. So if 1.4 eV was found in a first step for the top cell the 
new interval becomes 1.4 +/- 0.25. This is devided in 4 steps.....This 
iteration continous until the stepsize is less or equal to finestStep.\n"];

Options[calcEtaMax]={bandgapRangeList\[Rule]{},finestStep\[Rule]0.02,
      stepsPerInterval\[Rule]4,debug\[Rule]False};

makeUsage["export","etaOpt",
    "export[] saves a subset of values as plain text to 
a file for use in other programs. Options:\n
subset\[Rule]{}.... a list specifying which subset of data should be 
retrieved. x and y are placeholders other bandgaps must be set to a fix 
value. if only x is specified than a line of data will be returned. see also 
giveSubset\n
value\[Rule]\"eta\".. a string specifying the value which should be 
retrieved. at the moment only \"eta\" is available. if this option is not 
used, value->\"eta\" is used.\n
file\[Rule]\"\"...... the filename where to save the file. If this Option is 
not given a filename is generated via generateFilename and saved in the 
current dirctory use Directory[] to get the current directory.\n
comment->{{}}.... additional comments for export2Origin can be applied\n
I.e. export[subset->{x,y,0.7}] saves "];

Options[export]={subset\[Rule]{},value\[Rule]"eta",file\[Rule]"",
      comment\[Rule]{}};

makeUsage["generateFilename","etaOpt","generateFilename[] returns a filename 
based on the most important simulation parameters like cellstructure, 
spectrum, temperature, junction model, currentmodelling as string. I.e. 
(EE)(E)_100xAM1_5d_300K_1D_CM.dat. Available options:\n
extension->\"dat\".. appends the given extension instead of the default \"dat
\". i.e. extension->\"txt\"
add->\"\".. appends the given string to the filename without extension. i.e. \
generateFilename[add->\"muell\"]->\"(E)_am15d_1000x1000W_300K_1D_CM_1muell.\
dat\""];

Options[generateFilename] = {extension \[Rule] "",add->""};

makeUsage["giveBandgapList","etaOpt",
    "giveBandgapList[] returns a table of all 
bandgap combination for which the calculations should be performed. the range \

is set by the bandgapRAnge option in new[] or the setBandgapList[] method. 
giveBandgapPatternString is used to determine the cell structure.\n 
For a tandem cell the list looks like this:\n
{{1.8,0.8},{1.9,0.8},{2,0.8},{1.8,0.9}...}"];

makeUsage["giveBandgapRangeList","etaOpt",
    "giveBandgapRangeList[] returns the 
bandgap range list for which the calculation should be done. I.e. a 
\"RangeList\" in the form of {{2,3,0.05}{1,2,0.1}} means that the bandgap of 
the first cell should be varried from 2 to 3 eV with stepheights of 0.05 eV 
the bandgap of the second cell from 1 - 2 eV with a step height of 0.1eV."];

makeUsage["giveCell","etaOpt","giveCell[] returns the cell as object."];

makeUsage["giveData","etaOpt","giveData[] returns the raw data in the form 
{{{E1,E2,...},{eta}},...}."];

makeUsage["giveEta","etaOpt","giveEta[] returns the efficiency calculated by 
calcMpp in %."];

makeUsage["giveLambdaBegin","etaOpt",
    "giveLambdaBegin[] returns begining of the 
spectrum of the top cell in nm."];

makeUsage["giveMatrix","etaOpt","giveMatrix[] gives the calculated value in 
form of a Matrix. I.e. value->\"eta\",subset->{1,2,x,y} gives a matrix of  
efficiency, where cell1 = 1eV,cell2=2eV and cell3 and cell4 is varried. 
Options:\n
subset\[Rule]{}.... a list specifying which subset of data should be 
retrieved. x and y are placeholders other bandgaps must be set to a fix 
value. if only x is specified than a line of data will be returned. see also 
giveSubset\n
value\[Rule]\"eta\".. a string specifying the value which should be 
retrieved. at the moment only \"eta\" is available. if this option is not 
used, value->\"eta\" is used.\n
I.e. giveMatrix[subset->{x,y,0.7}] returns a subset of data of a tripple cell \

where the third bandgap = 0.7 eV."];

Options[giveMatrix]={subset\[Rule]{},value\[Rule]"eta"};

makeUsage["giveMaxValue","etaOpt","giveValueMax[value] returns the complete 
data set for which value becomes maximal. I.e. giveValueMax[\"eta\"] returns 
the maximum for a given set like this: {{1.6,1.},{46.81}}"];

makeUsage["giveMpp","etaOpt",
    "giveMpp[] returns the results of the calculation 
initiated with calcMpp[]."];

makeUsage["giveName","etaOpt",
    "giveName[] returns the name of the calculation 
as string."];

makeUsage["giveSpectrum","etaOpt",
    "giveSpectrum[] returns the selected spectrum 
as object."];

makeUsage["giveSubset","etaOpt","giveSubset[]  returns a subset of values. 
Options:\n
subset\[Rule]{}.... a list specifying which subset of data should be 
retrieved. x and y are placeholders other bandgaps must be set to a fix 
value. if only x is specified than a line of data will be returned. see also 
giveSubset\n
value\[Rule]\"eta\".. a string specifying the value which should be 
retrieved. at the moment only \"eta\" is available. if this option is not 
used, value->\"eta\" is used.\n
I.e. giveSubset[subset->{x,y,0.7}] returns a subset of data of a tripple cell \

where the third bandgap = 0.7 eV."];

Options[giveSubset]={subset\[Rule]{},value\[Rule]"eta"};

makeUsage["giveSubset2Matrix","etaOpt","giveSubset2Matrix[subset] converts a 
subset {{E11,E21,E31},...,value1},..}to a 
matrix{{value1,value2..},{value10..},...}"];

makeUsage["giveTitle","etaOpt","giveTitle[] returns "];

makeUsage["loadData","etaOpt","loadData[] loads back a simulation previously 
saved with saveData; uses Get[].Options:\n
file->\"\".. must be specified. loads this file."];

Options[loadAll]={file\[Rule]""};

makeUsage["plot","etaOpt","plot[] a contour or a line plot of the calculated 
data Options:\n
subset\[Rule]{}.... see givesubset[]\n
value\[Rule]\"eta\".. see givesubset[]\n
shaded\[Rule]True.. only valid for contour plots, if True the area between to \

lines is filled, else only lines with values area drawn.\n
color\[Rule]True... only valid for contour plots, if True color is used else 
a greyscale will be used."];

Options[plot]={subset\[Rule]{},value\[Rule]"eta",shaded\[Rule]True,
      color\[Rule]True};

makeUsage["saveData","etaOpt",
    "saveData[] saves the whole data with \"Save[]\", 
so that it can be loaded back with loadData[]. Options:\n
file->\"generateFilename[]\".. saves to the file given by this option. If 
this is option is not specified, saveData uses generateFilename[] to 
automatically set a filename."];

Options[saveData]={file\[Rule]""};

makeUsage["setCell","etaOpt",
    "setCell[mechStackCell] sets the complete stack of 
cell to the object of type mechStackCell."];

makeUsage["setLambdaBegin","etaOpt",
    "setLambdaBegin[] sets the begining of the 
spectrum of the top cell in nm."];

makeUsage["setSpectrum","mechStack",
    "setSpectrum[spectrum] sets the spectrum. 
\"spectrum\" is an object of type spectrum."];

makeUsage["setBandgapRangeList","etaOpt",
    "setBandgapRangeList[RangeList] sets 
the range, for which the calculation should be done. I.e. a \"RangeList\" in 
the form of {{2,3,0.05}{1,2,0.1}} means that the bandgap of the first cell 
should be varried from 2 to 3 eV with stepheights of 0.05 eV the bandgap of 
the second cell from 1 - 2 eV with a step height of 0.1eV."];



Begin["`Private`"];



spectrum::"doesNotExist" = " `1` is not a name of a 
spectrum. Use giveSpectrumNameList to get a complete list of all available 
spectra.";
spectrum::"notSpecified"="Spectrum is not specified. Use 
    giveSpectrumNameList and setSpectrum.";
spectrum::"notAString"="This is not a String. Please use 
    quotes.";

Class[spectrum,Object,{
    myList (* 
      the original spectrum asload as a liste units {nm,W/(m^2 um)} *) ,
    myFkt (* coresponding Interpolationsfunc. of the spectrum *) ,
    myGenFunc (* 
      interpolationfunction for calculating the number of photons *),
    myGenFuncType (* 0 for Interpolation order 0.... *),
    myLambdaBegin (* beginning of myList*),
    myLambdaEnd (* end myList*),
    myT (* temperature of blackbody*),
    myPurOrg (*integrated power of the origin spectrum between myLambaBegin,
      myLambdaEnd  in W/m^2*),
    myPur (*integrated power of the scaled spectrum between myLambaBegin in W/
          m^2*),
    myP0Org (*total power [0,\[Infinity]] of the  original spectrum in W/
          m^2*),
    myP0  (*total power [0,\[Infinity]] of the scaled spectrum in W/m^2*),
    myP1 (* user set power of the 1-sun spectrum *) ,
    myC (* der concentration factor *) ,
    myName (* Name of the spectrum *) ,
    myFileName (* Name & path of the spectrum *) ,
    mySolidAngle (*solid angle for blackbody *) ,
    mySpectrumPath (* Prefix for loadpath for spectra *) 
    },
  {
    {new,(Module[{op},
            super.new[];
            (* get parameter *)
            
            mySpectrumPath=spectrumPath/.{##}/.Options[spectrum];
            myC =concentration/.{##}/.concentration\[Rule]1;
            myP1=powerOfOneSun/.{##}/.powerOfOneSun\[Rule]1000;
            op=blackBody/.{##}/.blackBody\[Rule]True;
            (*set defaults*)
            
            myName:=If[myFileName\[Equal]"","",
                getFilenameWithoutExtension[myFileName]<>"_"<>outStr[myC,0,0]<>
                  "x"<>outStr[myP1,0,0]<>"W"];
            self.resetSpectrum[];
            myGenFuncType=genFuncType/.{##}/.genFuncType\[Rule]1;
            (* do we have a blackbody or a list of spectra data?*)
           
             If[op,
              self.generateBlackBody[##]
              ,
              op=name/.{##}/.name\[Rule]"AM1_5d/am15d.dat";
              self.setSpectrum[op]
              ];
            ])&},
    {generateBlackBody,(Module[{c=num[SpeedOfLight],
              h=num[PlanckConstant],k=num[BoltzmannConstant],
              q=num[ElectronCharge],
              myEpsilon,nl,dl},
            dbgPrint[Class[self],"generateBlackBody ##",##];
            myT=temperature/.{##}/.Options[generateBlackBody];
            myEpsilon=epsilon/.{##}/.Options[generateBlackBody];
            myLambdaBegin=Abs[lambdaBegin/.{##}/.Options[generateBlackBody]];
            myLambdaEnd=Abs[lambdaEnd/.{##}/.Options[generateBlackBody]];
            mySolidAngle=solidAngle/.{##}/.Options[generateBlackBody];
            If[myLambdaBegin> myLambdaEnd,
              nl=myLambdaBegin;
              myLambdaBegin=myLambdaEnd;
              myLambdaEnd=nl;
              ];
            If[myLambdaBegin\[LessEqual]0,myLambdaBegin=1*^-10];
            If[Length[{FilterOptions[{dLambda},##]}]>0,
              dbgPrint[Class[self],"generateBlackBody dLambda"];
              dl=dLambda/.{##}/.Options[dLambda];
              nl=Ceiling[(myLambdaEnd-myLambdaBegin)/dl];
              myLambdaEnd=nl*dl+myLambdaBegin;
              ,
              dbgPrint[Class[self],"generateBlackBody numberOfLambdas"];
              nl=numberOfLambdas/.{##}/.Options[generateBlackBody];
              dl=(myLambdaEnd-myLambdaBegin)/nl;
              ];
            
            dbgPrint[Class[self],"generateBlackBody nl:",nl," myLambdaBegin:",
              myLambdaBegin," myLambdaEnd:",myLambdaEnd," mySolidAngle:",
              mySolidAngle];
            (* bb_1x2000K_800-4000nm*)
            
            myFileName:="bb"<>outStr[myT,0,0]<>"K";
            Clear[myFkt,myGenFunc];
            
            myFkt[x_]:= 
              mySolidAngle/(4 Pi) myEpsilon 2 Pi h c^2 10^-6*1/(Exp[
                        h c/(k myT x 10^-9)]-1)*(x 10^-9)^-5 ;
            myGenFunc[x_]:= x myFkt[x];
            (*myEpsilon n[lambda]; 10^-6 units W/(m^2 \[Micro]m)*)
           
             myList:=
              Function[x,{x,myFkt[x]}]/@ 
                Table[(myLambdaEnd-myLambdaBegin)/nl*i+myLambdaBegin,{i,0,
                    nl}];
            
            myP0Org=myEpsilon 2 Pi^5 k^4/(15c^2 h^3)*myT^4 (*through Stefan-
                Boltzmann equation *);
            myPurOrg=myP0Org;
            (*W/(m^2 \[Micro]m) nm = 1/1000 W/m^2*);
            
            myP1=myP0Org(*set power of 1sun equal to total power of origin \
spectrum *);
            myP0=myC myP1;
            myPur=myP0 myPurOrg/myP0Org;
            ]) &},
    {giveConcentration,(myC)&},
    {giveGenFunc,(myGenFunc)&},
    {giveGenFuncType,(myGenFuncType)&},
    {giveList,(
          If[Length[myList]>0,
             myList /. {x_,y_}\[Rule]{x,myP1 myC/myP0Org y}
            ,
            Message[spectrum::"notSpecified"];
            {}
            ]) &},
    {giveName,(If[StringLength[myName]>0,myName,
            Message[spectrum::"notSpecified"]]) &},
    {giveFileName,(If[StringLength[myFileName]>0,myFileName,
            Message[spectrum::"notSpecified"]])&},
    {giveNameList,(Module[{p,s},
            p=mySpectrumPath;
            
            s=Cases[FileNames["*",p,Infinity],
                x_?(Function[x,FileType[x]\[Equal]File])\[Rule]x];
            StringReplace[s,p\[Rule]""]
            ]) &},
    {giveNumberOfPhotons,(Module[{lb,le,c=num[SpeedOfLight],
              h=num[PlanckConstant]},
            If[myName=="",Message[spectrum::"notSpecified"];Return[]];
            lb=lambdaBegin /. {##1} /. {lambdaBegin\[Rule]myLambdaBegin};
            le=lambdaEnd /. {##1} /. {lambdaEnd\[Rule]myLambdaEnd};
            lb=Max[lb,myLambdaBegin];
            le=Min[le,myLambdaEnd];
            dbgPrint[Class[self],"giveNumberOfPhotons lb:",lb," le:",le];
            If[interpolatingFunctionQ[myFkt],
              dbgPrint[Class[self],"giveNumberOfPhotons Integrate"];
              (myP0/myP0Org) 1.*^-12/(h c) Integrate[myGenFunc[zz],{zz,lb,le},
                  MaxRecursion->30]
              ,
              dbgPrint[Class[self],"giveNumberOfPhotons Integrate...//N"];
              (myP0/myP0Org) 1.*^-12/(h c) NIntegrate[
                  myGenFunc[zz],{zz,lb,le},MaxRecursion->30]
              ]
            ])&},
    {givePowerOfOneSun,(myP1)&},
    {givePowerOfOrigin,(myPurOrg)&},
    {givePower,(Module[{lb,le,r},
            If[myName=="",Message[spectrum::"notSpecified"];Return[]];
            lb=lambdaBegin /. {##1} /. {lambdaBegin\[Rule]-1};
            le=lambdaEnd /. {##1} /. {lambdaEnd\[Rule]\[Infinity]};
            (* if no limits return myPur, else perform integratation *)
      
                  If[lb<0||le>1*^999,
              myPur
              ,
              lb=Max[lb,myLambdaBegin];
              le=Min[le,myLambdaEnd];
              (* in W/m^2*);
              (* 
                factor 1/1000due to unit conversion: 
                      Spectrum in W/(m^2 \[Micro]m) nm =W/m^2 10^-3 *);
              If[interpolatingFunctionQ[myFkt],
                
                dbgPrint[Class[self],
                  "givePower NIntegrateInterpolatingFunction"];
                1.*^-3 myP0/myP0Org Integrate[myFkt[x],{x,lb,le}]
                ,
                dbgPrint[Class[self],"givePower Integrate...//N"];
                
                1.*^-3 myP0/myP0Org NIntegrate[myFkt[x],{x,lb,le},
                    MaxRecursion->30]
                ]
              ]
            ])&},
    {giveSpectrumPath,(mySpectrumPath)&},
    {giveTemperature,(myT)&},
    {giveTotalPower,(myP0(* in W/m^2*))&},
    {giveTotalPowerOfOrigin,(myP0Org(* in W/m^2*))&},
    {giveValue,(myFkt[#1])&},
    {giveValueList,(
          
          If[StringLength[myName]\[Equal]0,Message[spectrum::"notSpecified"];
            Return[];];
          myP0/myP0Org myList[[All,2]]
          ) &},
    {giveValueMin,(
          
          If[StringLength[myName]\[Equal]0,Message[spectrum::"notSpecified"];
            Return[];];
          (* units in W/m^2 \[Micro]m *)
          
          If[StringTake[myName,3]=="bb_",
            0
            ,
            myP0/myP0Org Min[myList[[All,2]]] 
            ]
          ) &},
    {giveValueMax,(
          
          If[StringLength[myName]===0,Message[spectrum::"notSpecified"];
            Return[];];
           (*units in W/m^2 \[Micro]m *)
          
          If[StringTake[myName,3]=="bb_",
            myFkt[2.897756*^6/myT](*Wien-Constant*)
            ,
            myP0/myP0Org Max[myList[[All,2]]]
            ]
          ) &},
    {giveWavelengthList,(
          
          If[StringLength[myName]===0,Message[spectrum::"notSpecified"];
            Return[];];
          (* units: nm *)
          myList[[All,1]]
          ) &},
    {giveWavelengthMin,(
          
          If[StringLength[myName]===0,Message[spectrum::"notSpecified"];
            Return[];];
           (* in nm *)
          myLambdaBegin
          ) &},
    {giveWavelengthMax,(
          
          If[(StringLength[myName]===0),Message[spectrum::"notSpecified"];
            Return[];];
           (* in nm *)
          myLambdaEnd
          ) &}, 
    {resetSpectrum,(
          myFileName="";
          myList={};
          myT=1*^-9;
          myFkt[x_]:=0;
          myGenFunc[x_]:=0;
          myLambdaBegin=0;
          myLambdaEnd=0;
          myP0Org=1;
          myPurOrg=1;
          myPur=myC myP1 myPurOrg/myP0Org;
          myP0=myC myP1;
          )&},
    {setConcentration,(
           If[NumericQ[#1],
              myC=#1;
              myP0=myC myP1;
              myPur=myC myP1 myPurOrg/myP0Org;
              ];) &},
    {setGenFunc,(myGenFunc=#1)&},
    {setGenFuncType,(
          
          dbgPrint[Class[self],"setGenFuncType #1: ",#1, 
            StringDrop[myFileName,StringLength[mySpectrumPath]]];
          myGenFuncType=#1;
          
          self.setSpectrum[
              StringDrop[myFileName,StringLength[mySpectrumPath]]];
          )&},
    {setPowerOfOneSun,(
          If[NumericQ[#1],
              myP1=#1;
              myP0=myC myP1;
              myPur=myC myP1 myPurOrg/myP0Org;
              ];)&},
    {setSpectrum,(Module[{p,s,tmpList},
            s=#1;
            p=connectDirs[mySpectrumPath,s];
            If[FileType[p]===File,
              myFileName =p;
              myList=readListWithComment[p](*W/(m^2 \[Micro]m)*);
              myFkt=Interpolation[myList,InterpolationOrder->1];
              
              Which[myGenFuncType\[Equal]1,(* 
                  Integrate \[Lambda] Interpol[E_m,0]d\[Lambda] === 
                    Summe E_m*\[Lambda]_m:*)
                
                tmpList=
                  Module[{x1=#[[1,1]],y1=#[[1,2]],x2=#[[2,1]],y2=#[[2,2]]},
                        {x2,(1/4 (y2+y1)(x1+x2))}
                        ]&/@Partition[myList,2,1];
                PrependTo[tmpList,{myList[[1,1]],0}];
                myGenFunc=Interpolation[tmpList,InterpolationOrder\[Rule]0]
                ,
                
                myGenFuncType\[Equal]2,(* 
                  Integrate \[Lambda] Interpol[E,1] d\[Lambda]  :*)
          
                      tmpList=
                  Module[{x1=#[[1,1]],y1=#[[1,2]],x2=#[[2,1]],y2=#[[2,2]]},
                        {x2, 1/6 (x1(2 y1+y2)+x2 (y1+2 y2))}
                        ]&/@Partition[myList,2,1];
                PrependTo[tmpList,{myList[[1,1]],0}];
                myGenFunc=Interpolation[tmpList,InterpolationOrder\[Rule]0]
                ,
                myGenFuncType\[Equal]3,(* Integrate[Interpol[\[Lambda] E,1]*)

                                tmpList=Module[{x=#[[1]],y=#[[2]]},
                        {x,x y}
                        ]&/@myList;
                myGenFunc=Interpolation[tmpList,InterpolationOrder\[Rule]1]
                ];(*end which*)
              
              myLambdaBegin=Min[myList[[All,1]]];
              myLambdaEnd=Max[myList[[All,1]]];
              
              myPurOrg = 
                1.*^-3Integrate[myFkt[x],{x,myLambdaBegin,myLambdaEnd},
                    MaxRecursion\[Rule]30];
              (*W/(m^2 \[Micro]m) nm = 1/1000 W/m^2*);
              myP0Org=myPurOrg;
              myPur=myC myP1 myPurOrg/myP0Org;
              myP0=myC myP1;
              ,
              self.resetSpectrum[];
              Message[spectrum::"doesNotExist", p];
              ];
            ])&},
    {setSpectrumPath,(mySpectrumPath=#1)&}
    }]







Class[singleJunction,Object,{
    myBandgap (* in eV *) ,
    myEqeMax (* EQE for E > Eg default = 1 *) ,
    mySpectrum (* Object Spectrum for Isc calculation*) ,
    myLambdaBegin (* 
      for Isc the spectrum will be integrated from LambdaBegin to Eg *) ,
    myTemperature (*  in K default = 300*) ,
    myName (* name of cell *) ,
    myIsc (*shortcircuit current, can be set, 
      if i.e. multijunction mA/cm^2*) ,
    myI0 (*saturation current mA/cm^2*) ,
    myno (*refractive index of overlaying material*),
    mynu (*refractive index of underlaying material*),
    myVoc (* in mV*)
    },
  {
    {new,(
          super.new[];
          myBandgap = bandgap /. {##1} /. Options[singleJunction];
          myName = name /. {##1}/.Options[singleJunction];
          myTemperature=temperature/.{##1}/.Options[singleJunction];
          myEqeMax=eqeMax/.{##1}/.Options[singleJunction];
          myno=no/.{##1}/.Options[singleJunction];
          mynu=nu/.{##1}/.Options[singleJunction];
          myIsc=0;
          myI0 = 0;
          myLambdaBegin=0;
          myVoc=Infinity;
          )&},
    {calcAll,(
          self.calcIsc[];
          self.calcI0[];
          self.calcVoc[];
          )&},
    {calcIsc,(self.NIM[calcIsc])&},
    {calcI0,(self.NIM[calcI0])&},
    {calcVoc,(self.NIM[calcVoc])&},
    {giveBandgap,(myBandgap)&},(*in eV*)
    {giveEg,(myBandgap)&},(*in eV*)
 \
   {giveEqeMax,(myEqeMax)&},
    {giveIsc,(myIsc)&},(*mA/cm^2*)
    {giveI0,(myI0)&},(*mA/
        cm^2*)
    {giveLambdaBegin,(myLambdaBegin)&},(*nm*)
    \
{giveLambdaG,(Module[
            {c=num[SpeedOfLight],h=num[PlanckConstant],
              q=num[ElectronCharge]},
            (10^9h c/ q) /  myBandgap (*eV \[Rule] nm*)
            ])&},
    {giveModelAcronym,("SJ")&},
    {giveName,(ToString[myName])&},
    {giveTemperature,(myTemperature)&},(*in K*)
    {giveno,(myno)&},
    {givenu,(mynu)&},
    {giveSpectrum,((mySpectrum))(*Object Spectrum*)&},
    {giveV,(self.NIM[giveV](*I in mA/cm^2*))&},
    {setBandgap,(myBandgap = #1;)&},
    {setEqeMax,(myEqeMax = #1;)&},
    {setIsc,(myIsc = #1;)&},
    {setI0,(myI0 = #1;)&},
    {setLambdaG,(Module[
            {c=num[SpeedOfLight],h=num[PlanckConstant],
              q=num[ElectronCharge]},
            myBandgap=(h c/ q)  / #1;
            ])&},
    {setName,(myName = #1;)&},
    {setSpectrumBegin,(
          mySpectrum=#1;
          myLambdaBegin=#2;
          )&},
    {setTemperature,(myTemperature = #1;)&},
    {setno,(myno = #1;)&},
    {setnu,(mynu = #1;)&}
    }
  ]









Class[oneDiodeJunction,singleJunction,{},
  {
    {new,(super.new[##1])&},
    {calcIsc,(Module[{q=num[ElectronCharge]},
            
            myIsc=myEqeMax q mySpectrum.giveNumberOfPhotons[
                    lambdaBegin\[Rule]myLambdaBegin,
                    lambdaEnd\[Rule]self.giveLambdaG[]] * 
                0.1;(*0.1 unit conversion see below *)
            
            dbgPrint[Class[self],"calcIsc myLambdaBegin:",myLambdaBegin,
              " self.giveLambdaG[]:",self.giveLambdaG[]," myIsc:",myIsc];
            ])&},
    {calcI0,(Module[{c=num[SpeedOfLight],h=num[PlanckConstant],
              k=num[BoltzmannConstant],q=num[ElectronCharge],Eg,T},
            Eg=myBandgap;
            T=myTemperature;
            
            myI0=(2 q Pi (myno^2+
                          mynu^2))/(h^3 c^2)(k T (q Eg)^2-2 q Eg(k T)^2+2(k \
T)^3) Exp[(-q Eg)/(k T)] 0.1;(*0.1 unit conversion see below*)
            \
])&},
    {calcVoc,(Module[{k=num[BoltzmannConstant],q=num[ElectronCharge]},
            
            myVoc=(k myTemperature)/q Log[myIsc/myI0] 1000;(* 
              1000 unit conversion see below*)
            ])&},
    {giveModelAcronym,("1D")&},
    {giveV,(Module[{k=num[BoltzmannConstant],q=num[ElectronCharge]},
            (k  myTemperature)/q Log[(myIsc - #1)/myI0+1] 1000
            (*1000  unit conversion see below*)
            ])&}
    }
  ]









Class[oneDiodeJunctionI0FirstTerm,oneDiodeJunction,{},
  {
    {new,(super.new[##1])&},
    {calcI0,(Module[{c=num[SpeedOfLight],h=num[PlanckConstant],
              k=num[BoltzmannConstant],q=num[ElectronCharge],Eg,T},
            Eg=myBandgap;
            T=myTemperature;
            
            myI0=(2 q Pi (myno^2+
                          mynu^2))/(h^3 c^2)(k T(q Eg)^2)Exp[(-q Eg)/(k T)] \
0.1;
            ])&},
    {giveModelAcronym,("1D1T")&},
    {giveV,(Module[{k=num[BoltzmannConstant],
              q=num[ElectronCharge]},(k myTemperature)/
                q Log[(myIsc-#1)/myI0] 1000])&}
    }
  ]





Class[oneDiodeJunctionSemiEmpirical,oneDiodeJunction,{myI0Func},
  {
    {new,(
          super.new[##1];
          myI0Func=i0Func/.{##1}/.Options[oneDiodeJunctionSemiEmpirical];
          )&},
    {calcI0,(Module[{Eg,T,C},
            Eg=myBandgap;
            T=myTemperature;
            C=mySpectrum.giveConcentration[];
            myI0=myI0Func[Eg,T,C];
            ])&},
    {giveI0Func,(myI0Func)&},
    {giveModelAcronym,("1Dse")&},
    {setI0Func,(myI0Func=#1)&}
    }
  ]







Class[container,Object,{
    myList,(* Liste of objects of type singleJunction *)
    
    myName, (* Name of cell *)
    
    curPos (* current position in cellstack for givenext...*)
    },
  {
    {new,(
          super.new[];
          myName = name /. {##1} /. Options[container];
          myList = item /. {##1} /. Options[container];
          curPos=If[Length[myList]>0,1,0];
          )&},
    {appendTo,(
          If[ListQ[#1],
              Function[x,AppendTo[myList,x]]/@(#1);
              ,
              AppendTo[myList,(#1)];
              ];
          )&},
    {evaluateForEachItem,(
          If[First[myList].isa[container],
            Function[x,x.evaluateForEachItem[#1]]/@(self.giveList[])
            ,
            Function[x,x.#1]/@(self.giveList[])
            ]
          )&},
    {giveCurrent,(If[curPos>0,(myList[[curPos]]),(Null)])&},
    {giveItem,(If[Min[Length[myList],Max[0,#1]]>0,(myList[[#1]]),(Null)])&},
    {giveName,(myName)&},
    {giveList,(myList)&},
    {giveFirst,(
          If[move/.{##1}/.move\[Rule]True,
            curPos=Min[1,Length[myList]];
            If[curPos>0,(myList[[curPos]]),(Null)]
            ,
            If[Min[1,Length[myList]]>0,(myList[[1]]),(Null)]
            ]
          )&},
    {giveLast,(
          If[move/.{##1}/.move\[Rule]True,
            curPos=Length[myList];
            If[curPos>0,(myList[[curPos]]),(Null)]
            ,
            If[Length[myList]>0,(myList[[curPos]]),(Null)]
            ]
          )&},
    {giveNumberOf,(Length[myList])&},
    {giveNext,(
          If[move/.{##1}/.move\[Rule]True,
            curPos=Min[++curPos,Length[myList]+1];
            If[curPos\[LessEqual]Length[myList],(myList[[curPos]]),(Null)]
            ,
            
            If[curPos+1\[LessEqual]
                Length[myList],(myList[[curPos+1]]),(Null)]
            ]
          )&},
    {givePosition,(curPos)&},
    {givePrevious,(
          If[move/.{##1}/.move\[Rule]True,
            curPos=Max[--curPos,0];
            If[curPos\[GreaterEqual]1,(myList[[curPos]]),(Null)]
            ,
            If[curPos-1\[GreaterEqual]1,(myList[[curPos-1]]),(Null)]
            ]
          )&},
    {isFirst,(If[curPos==1,True,False])&},
    {isLast,(If[curPos==Length[myList],True,False])&},
    {setName,(myName = #1;)&},
    {setList,(myList = #1;)&},
    {moveToFirst,(curPos=Min[1,Length[myList]];)&},
    {moveToLast,(curPos=Length[myList];)&},
    {moveTo,(curPos=Min[Length[myList],Max[0,#1]];)&}
    }
  ]





Class[monoStack,container,{
    currentMatching (*true if current matching should be used*),
    myPmpp(* in mW/cm^2*),
    myImpp(* in mA/cm^2*),
    myVmpp(* in mV*),
    myIsc (* in mA/cm^2*)},
  {
    {new,(Module[{op},
            super.new[##1];
            op =currentMatching /. {##1} /. currentMatching\[Rule]True;
            self.setCurrentMatching[op];
            ])&},
    {calcIsc,(Module[{sc,Iplus,Idif},
            sc=super.giveFirst[];
            myIsc=0;
            Iplus=0;
            Idif=0;
            
            Function[x,
                x.calcIsc[]]/@(super.giveList[]);(*calculated Isc of all \
cells*);
             (* set Isc to mean value of Isc of all cells*);
            
            myIsc=(Plus @@ Function[x,x.giveIsc[]]/@(super.giveList[]))/
                super.giveNumberOf[];
            sc=super.giveFirst[];
            (* set Isc to maximum possible isc value*);
            If[self.giveCurrentMatching[],
              While[sc.isa[Object]===True,
                If[sc.giveIsc[]\[GreaterEqual]myIsc,
                  Iplus+=sc.giveIsc[]-myIsc;
                  ,(*Isc<myIsc*)
                  
                  Idif=Min[Iplus,myIsc-sc.giveIsc[]];
                  myIsc=sc.giveIsc[]+Idif;
                  Iplus-=Idif;
                  ];(*Endif*);
                sc=super.giveNext[]
                ];(*Wend sc*);
              (* 
                no currentmatching \[Rule] 
                  set myIsc to minimum of all Isc in the Stack*);
              ,
              myIsc=Infinity;
              myIsc= Min @@ Function[x, x.giveIsc[]]/@ (super.giveList[]);
              ];(*EndIf currentMatching*);
            (*set Isc of all cells to myIsc*);
            Function[x,x.setIsc[myIsc]]/@(super.giveList[]);
            ])&},
    {calcMpp,(Module[{sc,P,V},
            sc=super.giveFirst[];
            While[sc.isa[Object]===True,
              sc.calcI0[];
              sc=super.giveNext[];
              ];
            (*build power function P=I*\[CapitalSigma] V(I) *)
            
            V[Ix_]:=Plus @@
                Function[scc,scc.giveV[Ix]]/@(self.giveList[])(*in mV*);
            
            P[Ix_]:=Ix V[Ix] 10^-3(* in mW/cm^2; 
              10^-3 due to unit conversion: mA/cm^2*mV=10^3 mW/cm^2*);
            (*1. derivative = 0 *);
            
            dbgPrint[Class[self],"calcMpp self.First.Isc:",
              self.giveFirst[].giveIsc[]];
            
            myImpp=Ix/.FindRoot[
                  P'[Ix],{Ix,
                    self.giveFirst[].giveIsc[]*0.99}](*0.99Isc only start \
value*);
            myPmpp=P[myImpp](*in mW/cm^2*);
            myVmpp=V[myImpp](*in mV*);
            
            dbgPrint[Class[self],"calcMpp Mpp: P:",myPmpp," V:",myVmpp," I:",
              myImpp];
            ])&},
    {giveCurrentMatching,(currentMatching) &},
    {giveIsc,(myIsc) &},
    {giveImpp,(myImpp) &},
    {givePmpp,(myPmpp) &},
    {giveVmpp,(myVmpp) &},
    {setCurrentMatching,(currentMatching=#1;)&},
    {setBandgap,(Module[{sc,Es},
            Es=#1;
            sc=super.giveFirst[](* assign new bandgaps *) ;
            While[sc.isa[Object]===True,
              sc.setBandgap[First[Es]];
              Es=Drop[Es,1];
              sc=super.giveNext[];
              ];
            ])&},
    {setSpectrumBegin,(Module[{sc},
            sc=super.giveFirst[];
            sc.setSpectrumBegin[#1,#2];
            sc=super.giveNext[];
            
            While[sc.isa[Object]===True, (*go trough all cells*)
             
               sc.setSpectrumBegin[#1,
                  super.givePrevious[move\[Rule]False].giveLambdaG[]];
              sc=super.giveNext[];
              ];
            ])&},
    {setTemperature,(
          Function[x,x.setTemperature[#1]] /@ (super.giveList[]);
          )&}
    }
  ]



Class[mechStack,container,{
    myPmpp
    (* name, and list comes from container*)},
  {
    {new,(Module[{op},
            super.new[##1];
            ])&},
    {calcMpp,(
          Function[x,x.calcIsc[]]/@(super.giveList[]);
          Function[x,x.calcMpp[]]/@(super.giveList[]);
          
          dbgPrint[Class[self],"calcMpp Pmpp:",
            Function[x,x.givePmpp[]]/@(super.giveList[])];
          
          myPmpp=(Plus @@ 
                Function[x,x.givePmpp[]]/@(super.giveList[]));(*in mW/
                cm^2*)
          )&},
    {giveBandgapPatternString,(Module[{mono,sc,i=1,str="{"},
            mono=super.giveFirst[];
            While[mono.isa[Object]===True,
              (*if not first element then add coma*)
              
              If[StringTake[str,-1]=!="{",str=str<>","];
              str=str<>"{";
              sc=mono.giveFirst[];
              While[sc.isa[Object]===True,
                (*if not first element then add coma*)
                
                If[StringTake[str,-1]=!="{",str=str<>","];
                str=str<>"E"<>ToString[i];
                i++;
                sc=mono.giveNext[];
                ];(*Wend sc*)
              str=str<>"}";
              mono=super.giveNext[];
              ];(*Wend mono*)
            str<>"}"
            ])&},
    {givePmpp,(myPmpp)&},
    {setBandgap,(Module[{mono,Es=#1},
            mono=super.giveFirst[];
            (* assign RangeList to MonoStack *)
            
            While[mono.isa[Object]===True,(* 
                loop through all monoStacks in MechStack*)
              
              mono.setBandgap[First[Es]];
              Es=Drop[Es,1];
              mono=super.giveNext[];
              ];
            ])&},
    {setSpectrumBegin,(Module[{mono,lb,sp},
            sp=spectrum/.{##1};
            lb=lambdaBegin/.{##1}/.lambdaBegin\[Rule]sp.giveWavelengthMin[];
            lb = Min[lb,sp.giveWavelengthMin[]];
            mono=super.giveFirst[];
            (*spectrum of the first monostack begins with the beginning of \
the spectrum*)
            mono.setSpectrumBegin[(sp),lb];
            mono=super.giveNext[];
            
            While[mono.isa[Object]===
                True,(*loop through all monostacks of the cell*)
             \
 (* spectrum of all following monostacks begins with the smallest bandgap of \
the above laying monostack *)
              
              mono.setSpectrumBegin[(sp),
                  super.givePrevious[
                      move\[Rule]False].giveLast[].giveLambdaG[]];
              mono = super.giveNext[];
              ];
            ])&},
    {setTemperature,(Function[x,
              x.setTemperature[#1]] /@ (super.giveList[]))&}
    }
  ]







etaOpt::"FileNotFound" = "Could not find file `1`.";
etaOpt::"subsetXNeeded" = "The subset pattern must contain 
    a 'x'.";
etaOpt::"wrongSubset" = "Length of the subset pattern must 
    be the same as the number of bandgaps.";

Class[etaOpt,Object,{
    myName (* name of the Calculation *) ,
    myCell (* object CellStack with all junctions *) ,
    mySpectrum (* object spectrum to use for calculation*),
    myLambdaBegin,
    myEta,
    myRangeList (* 
      range to be investigated {{Etop1,Etop2},{Ebot1,Ebot2},...} *) ,
    myData (* 
      all data in the form{{{E1,E2,...},{eta,
              Pmpp,...}},{{E..},{eta..}}} *) },
  {
    {new,(
          super.new[];
          myName = name /. {##1} /.name\[Rule]"";
          myCell = item /. {##1} /.item\[Rule]mechStack.new[];
          mySpectrum=spectrum/.{##1}/.spectrum->spectrum.new[];
          myLambdaBegin=lambdaBegin/.{##1}/. Options[etaOpt];
          myRangeList=bandgapRange/.{##1}/.bandgapRange\[Rule]{};
          myData={};
          )&},
    {calcAll,(Module[{myTime},
            myTime=SessionTime[];
            
            myData=self.giveBandgapList[](*generate empty table containing \
all bandgaps to be calculated{{{{2,1},{0.3}}},{{{2,1},{0.31}}},...}*);
            
            myData=Function[x,self.calcMpp[x];{x,self.giveMpp[]}]/@ 
                myData[[All,1]];
            
            myData=Function[
                  x,{Flatten[First[x]],
                    Last[x]}]/@(myData)(*flaten list {{E1,E2},{E3}}->{E1,E2,
                  E3}*);
            showStatus["Done in "<>ToString[SessionTime[]-myTime]<>" s"];
            ])&},
    {calcEtaMax,(Module[{rangeList,tmpRangeList,steps,finest,etaMax,stop},
            steps=stepsPerInterval/.{##1}/.Options[calcEtaMax];
            rangeList=bandgapRangeList/.{##1}/.Options[calcEtaMax];
            finest=finestStep/.{##1}/.Options[calcEtaMax];
            (*{min,max,step,optFromLastCalc}*)
            
            rangeList=
              Function[x,{x[[1]],x[[2]],(x[[2]]-x[[1]])/steps,x[[1]]}]/@
                rangeList;
            stop=Function[x,False]/@rangeList;
            While[True,
              
              tmpRangeList=(Function[x,
                      If[stop[[(Position[rangeList,x])[[1,1]]]],{x[[4]],
                          x[[4]],1},{x[[1]],x[[2]],x[[3]]}]]/@rangeList);
              self.setBandgapRangeList[tmpRangeList];
              dbgPrint[Class[self],"calcEtaMax Calc with: ",tmpRangeList];
              self.calcAll[];
              etaMax=self.giveMaxValue[];
              dbgPrint[Class[self],"calcEtaMax Max: ",etaMax];
              stop=Function[x,x[[3]]<=finest]/@rangeList;
              If[Max[rangeList[[All,3]]]\[LessEqual]finest,Break[]];
              
              rangeList=
                Function[x,
                    Flatten[{x[[{1,2,3}]],
                        etaMax[[1,Position[rangeList,x]//First//First]]}]]/@
                  rangeList;
              
              rangeList=(Function[
                      x,{x[[4]]-x[[3]],x[[4]]+x[[3]],(2 x[[3]])/steps,
                        x[[4]]}]/@rangeList);
              ];
            etaMax
            ])&},
    {calcMpp,(Module[{ok,Es,pos},
            Es=Flatten[{##}];
            showStatus[ToString[Es]](*message in Statusrow *);
            (* verify that E1>E2>E3...*);
            ok = OrderedQ[Es,Function[{x,y},x>y]];
            Es=#1;
            If[ok,
              dbgPrint[Class[self],"calcMpp Es:",Es];
              myCell.setBandgap[Es];
              
              myCell.setSpectrumBegin[spectrum->mySpectrum,
                  lambdaBegin\[Rule]myLambdaBegin] ;
              myCell.calcMpp[];
              
              dbgPrint[Class[self],"calcMpp Pmpp:",myCell.givePmpp[]," P:",
                mySpectrum.giveTotalPower[]];
               myEta=100*myCell.givePmpp[]/mySpectrum.giveTotalPower[]*10
              (*in %; 
                10 due to unit conversion:(mW/cm^2)/(W/m^2)=(10^-3W/
                            10^-4m^2)/(W/m^2)=10*);
              ,
              myEta=0;
              ](*EndIf E1>E2...*);
            showStatus[""];
            ])&},
    {export,(Module[{ss,ma,xt,yt,zt,z1,z2,com,opss,opval,opfile,opcomment},
            opss=subset/.{##1}/.Options[export];
            opval=value/.{##1}/.Options[export];
            opfile=file/.{##1}/.file\[Rule]self.generateFilename[];
            opcomment=comment/.{##1}/.Options[export];
            Which[opss\[Equal]{},
              (*export all data*)
              
              ss=Function[x,Flatten[x]]/@ (myData);
              
              com=opcomment~
                  Join~{{"title",ToString[self.giveName[]]},{"note",
                      self.giveTitle[]}};
              dbgPrint[Class[self],"export: com vor Union:",com];
              
              com=Function[x,First@Select[com,Function[y,x\[Equal]y[[1]]]]]/@
                  Union[com[[All,1]]];
              dbgPrint[Class[self],"export: com nach Union:",com];
              export2Origin[{"data"\[Rule]ss,
                  "filename"\[Rule]opfile,
                  "comment"\[Rule]com,
                  ##1}]
              ,
              
              Position[ToString/@opss,"x"]=!={} && 
                Position[ToString/@opss,"y"]=!={},
              (*contourplot*)
              
              dbgPrint[Class[self],"export: contourPlot"];
              
              xt="Bandgap of "<>(Flatten[
                        myCell.evaluateForEachItem[giveName[]]])[[Position[
                          ToString/@opss,"x"][[1,1]]]]<>" [eV]";
              yt="Bandgap of "<>
                  Flatten[
                      myCell.evaluateForEachItem[giveName[]]][[Position[
                          ToString/@opss,"y"][[1,1]]]]<>" [eV]";
              zt="eta [%]";
              z2=Max[1,Ceiling[Max[ma]]];
              z1=Max[z2-10,0];
              ss=self.giveSubset[##1];
              ma=self.giveMatrix[##1];
              com=opcomment~Join~{
                    {"title",ToString[self.giveName[]]},
                    {"xtitle",xt},
                    {"ytitle",yt},
                    {"ztitle",zt},
                    {"xmin",Min[ss[[All,1]]]},
                    {"xmax",Max[ss[[All,1]]]},
                    {"ymin",Min[ss[[All,2]]]},
                    {"ymax",Max[ss[[All,2]]]},
                    {"zmin",z1},
                    {"zmax",z2},
                    {"zcount",(z2-z1)},
                    {"note",self.giveTitle[]}};
              dbgPrint[Class[self],"export: com vor Union:",com];
              
              com=Function[x,First@Select[com,Function[y,x\[Equal]y[[1]]]]]/@
                  Union[com[[All,1]]];
              dbgPrint[Class[self],"export: com nach Union:",com];
              export2Origin[{"data"\[Rule]ma,
                  "filename"\[Rule]opfile,
                  "dataType"->"matrix",
                  "comment"\[Rule]com}],
              Position[ToString/@opss,"x"]=!={},
              dbgPrint[Class[self],"export: linePlot"];
              (*linePlot*)
              
              xt="Bandgap of "<>
                  Flatten[
                      myCell.evaluateForEachItem[giveName[]]][[Position[
                          ToString/@opss,"x"][[1,1]]]]<>" [eV]";
              yt="Efficiency [%]";
              ss=self.giveSubset[##1];
              ma=self.giveMatrix[##1];
              com=opcomment~Join~{{"title",ToString[self.giveName[]]},
                    {"xtitle",xt},
                    {"ytitle",yt},
                    {"xmin",Min[ss[[All,1]]]},
                    {"xmax",Max[ss[[All,1]]]},
                    {"ymin",Min[ss[[All,2]]]},
                    {"ymax",Max[ss[[All,2]]]},
                    {"note",self.giveTitle[]}};
              dbgPrint[Class[self],"export: com vor Union:",com];
              
              com=Function[x,First@Select[com,Function[y,x\[Equal]y[[1]]]]]/@
                  Union[com[[All,1]]];
              dbgPrint[Class[self],"export: com nach Union:",com];
              export2Origin[{"data"\[Rule]ss,
                  "filename"\[Rule]opfile,
                  "dataType"->"list",
                  "comment"\[Rule]com}]
              ];
            ])&},
    {generateFilename,(Module[{str,str2,opext,opadd},
            opext=extension/.{##1}/.extension\[Rule]"dat";
            opadd=ToString[add/.{##1}/.add\[Rule]""];
            If[StringTake[opext,1]=!=".",opext="."<>opext];
            (* build band structure  *)
            
            str=StringReplace[
                myCell.giveBandgapPatternString[],{"{"\[Rule]"(","}"->")",
                  ","\[Rule]""}];
            For[i=100,i>0,str=StringReplace[str,ToString[i]\[Rule]""];i--];
            str=StringTake[str,{2,-2}]<>"_";
            (* spectrum *)
            str=str<>(mySpectrum.giveName[])<>"_";
            (* Temperature *)
            
            str=str<>ToString[
                  myCell.giveFirst[].giveFirst[].giveTemperature[]]<>"K_";
            (* JunctionModel *)
            
            str=str<>
                ToString[(myCell.giveFirst[].giveFirst[]).giveModelAcronym[]];\

            (* Currentmatching *)
            
            If[myCell.giveFirst[].giveCurrentMatching[],str=str<>"_CM"];
            (* Interpolation Order of Genfunc *)
            
            str=str<>"_"<>outStr[mySpectrum.giveGenFuncType[],0,0];
            str=str<>opadd;
            str=str<>opext;
            str
            ])&},
    {giveBandgapList,(
          Module[{cmd,bandgapPattern,mr={}},
            showStatus["Building bandgap list"];
            
            bandgapPattern=ToExpression[myCell.giveBandgapPatternString[]](* 
              returns a list of all bandgaps z.b. "{{E1,E2},{E3}}"*);
            mr=myRangeList;
            
            For[i=1,i\[LessEqual]Length[mr],
              mr=Insert[mr,ToExpression["E"<>ToString[i]],{i,1}];i++];
            m=Table[Evaluate[{bandgapPattern}],Evaluate[Sequence@@mr]];
            showStatus[""];
            Flatten[m,Depth[m]-5]
            ])&},
    {giveBandgapRangeList,(myRangeList)&},
    {giveCell,(myCell)&},
    {giveData,(myData)&},
    {giveEta,(myEta)&},
    {giveLambdaBegin,(myLambdaBegin)&},
    {giveMatrix,(self.giveSubset2Matrix[self.giveSubset[##1]])&},
    {giveMaxValue,(Module[{val},
            If[Length[{##1}]>0,val={##1}//First,val="eta"];
            val=self.giveValuePosition[val];
            Flatten[
              Select[myData,
                Function[x,x[[2,val]]\[Equal]Max@@myData[[All,2,val]]]
                ],1]
            ])&},
    {giveMpp,( {myEta})&},
    {giveName,(myName)&},
    {giveSpectrum,(mySpectrum)&},
    {giveSubset,(Module[{sub,xpos,ypos,val},
            sub=subset/.{##1}/.subset\[Rule]{};
            val=value/.{##1}/.value\[Rule]"eta";
            
            If[Length[sub]\[NotEqual]Length[myData//First//First],
              Message[etaOpt::wrongSubset];Return[{}]];
            xpos=Position[ToString/@sub,"x"];
            If[xpos=={},xpos=0,xpos=xpos//First//First];
            ypos=Position[ToString/@sub,"y"];
            If[ypos=={},ypos=0,ypos=ypos//First//First];
            
            sub=ToExpression[
                "{"<>StringReplace[
                    ToString[sub],{"x"\[Rule]"_","y"\[Rule]"_"}]<>",{__}}"];
            val=self.giveValuePosition[val];
            Which[xpos\[Equal]0&&ypos\[Equal]0,
              Message[etaOpt::subsetXNeeded];Return[{}],
              xpos\[NotEqual]0&&ypos\[Equal]0,
              (Function[x,{myData[[x[[1]],1,xpos]],myData[[x[[1]],2,val]]}]/@
                    Position[myData,sub])//Sort,
              xpos\[NotEqual]0&&ypos\[NotEqual]0,
              (Function[
                      x,{myData[[x[[1]],1,xpos]],myData[[x[[1]],1,ypos]],
                        myData[[x[[1]],2,val]]}]/@Position[myData,sub])//Sort
              ]
            ])&},
    {giveSubset2Matrix,(Module[{m},
            m=#1;
            (Function[y,m[[y,3]]]/@
                  Function[x,Position[m,{x,_,_}][[All,1]]]/@
                    Union[m[[All,1]]])//Transpose
            ])&},
    {giveTitle,(Module[{op,str},
            op=style/.{##1}/.style\[Rule]"";
            str="";
            Which[op\[Equal]"origin",
              
              str="Sim-Name="<>ToString[self.giveName[]]<>"\n"<>
             
                       " Datei="<>
                  ToString@
                    ToFileName[
                      "FileName" /.NotebookInformation[
                          FrontEnd`EvaluationNotebook[]]]<>"\n"<>
            
                        "Datum="<>
                  ToString[
                    StringForm["`3`.`2`.`1`, `4`:`5`",
                      Sequence@@ToString/@Date[]]]<>"\n"<>
                  
                  "Zellstruktur="<>
                  ToString[myCell.giveBandgapPatternString[]]<>
              
                      "Zelltemp="<>
                  ToString[myCell.evaluateForEachItem[giveTemperature[]]]<>
                  "\n"<>
                  "SpektrumName="<>
                  ToString[mySpectrum.giveName[]]<>"\n"<>
                  
                  " SpektrumConc="<>ToString[mySpectrum.giveConcentration[]]<>
                  "\n"<>
                  "SpektrumP1="<>
                  ToString[mySpectrum.givePowerOfOneSun[]]<>"\n"
              ,
              op\[Equal]"",
              
              str="Max at: "<>ToString[self.giveMaxValue[]]<>"\n"<>
          
                          "Zellstruktur: "<>
                  ToString[myCell.giveBandgapPatternString[]]<>
              
                      ", T="<>
                  ToString[myCell.evaluateForEachItem[giveTemperature[]]]<>
                  "\n"<>
                  "Spektrum: "<>
                  ToString[mySpectrum.giveName[]]<>"\n"<>
                  
                  "Datum: "<>
                  ToString[
                    StringForm["`3`.`2`.`1`, `4`:`5`",
                      Sequence@@ToString/@Date[]]]];
            str
            ])&},
    {giveValuePosition,(Module[{valList={"eta"},v=ToLowerCase[#1]},
            If[Position[valList,v]=!={},Position[valList,v][[1,1]],0]
            ])&},
    {plot,(Module[{ss,ma,mr,zr,ls,titel,lf,opss,opval,opShaded,opColor},
            opss=subset/.{##1};
            opval=value/.{##1}/.value\[Rule]"eta";
            opShaded=shaded/.{##1}/.shaded\[Rule]True;
            opColor=color/.{##1}/.color\[Rule]True;
            titel=self.giveTitle[];
            ss=self.giveSubset[##1];
            ma=self.giveMatrix[##1];
            
            mr={{Min[ss[[All,1]]],Max[ss[[All,1]]]},{Min[ss[[All,2]]],
                  Max[ss[[All,2]]]}};(*MeshRange*)
            
            ls={(Max[ss[[All,1]]]-Min[ss[[All,1]]])/
                  4,(Max[ss[[All,2]]]-Min[ss[[All,2]]])};(*LegendSize*)
      
                  lf={"Arial",12};
            zr={Max[1,Ceiling[Max[ma]]]};
            zr=PrependTo[zr,Max[zr[[1]]-10,0]];
            Which[
              Length[ss[[1]]]\[Equal]2,(*Line*)
              
              ListPlot[ss,AxesLabel\[Rule]{"bandgap [eV]","efficiency [%]"}]
              ,
              
              Length[ss[[1]]]\[Equal]3&&
                opShaded\[Equal]False,(*Matrix with LineLabels*)
             
               LabelContourLines[ListContourPlot[ma,MeshRange\[Rule]mr,
                  PlotLabel\[Rule]titel,
                  DefaultFont\[Rule]lf,
                  ContourShading\[Rule]False,
                  ImageSize\[Rule]800,
                  DisplayFunction\[Rule]Identity],
                LegendSize\[Rule]ls,
                LabelFont\[Rule]lf]
              ,
              Length[ss[[1]]]\[Equal]3&&opShaded,(*Matrix shaded with Legend*)

                            LabelContourLegend[ListContourPlot[ma,
                    FilterOptions[ListContourPlot,##1],
                    MeshRange\[Rule]mr,
                    PlotRange\[Rule]zr,
                    PlotLabel\[Rule]titel,
                    DefaultFont\[Rule]lf,
                    ContourShading\[Rule]True,
                    
                    ColorFunction\[Rule]
                      Evaluate[
                        If[opColor,Function[x,Hue[0.8*(1-x)]],
                          Function[x,GrayLevel[1-x]]]],
                    ImageSize\[Rule]800,
                    DisplayFunction\[Rule]Identity],
                  FilterOptions[LabelContourLegend,##1],
                  HeightName\[Rule]opval,
                  LegendSize\[Rule]ls,
                  LabelFont\[Rule]lf];
              ];
            ])&},
    {saveData,(Module[{opfile},
            
            opfile=file/.{##1}/.file\[Rule]
                  self.generateFilename[extension\[Rule]"me"];
            Save[opfile,myData]])&},
    {loadData,(Module[{opfile,para},
            opfile=file/.{##1}/.file\[Rule]"";
            
            If[FileNames[ToString[opfile]]\[Equal]{},
              Message[etaOpt::"FileNotFound",opfile]; Return[];];
            Get[opfile];])&},
    {setBandgapRangeList,(myRangeList=#1)&},
    {setCell,(myCell = #1)&},
    {setLambdaBegin,(myLambdaBegin=#1)&}
    }
  ]









End[];(*Private*)

EndPackage[];